//! \file    CtinWindow.cpp
//! \brief   Implementation of the Ctin window.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

/*
  Nom du Fichier: CtinWindow.cpp
  Nom de classe: CtinWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

//! \class CtinWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Ctin window for visual_YAO.

#include "Include/CtinWindow.hpp"


CtinWindow::CtinWindow(QWidget *parent) : QWidget(parent) { /*!< The constructor. */

    this->setWindowTitle(" Directive Ctin. "); /*!< To set the window's title. */
    this->resize(700, 518);   /*!< To set the window's size. */
	
    centralWidget = new QWidget(this);    /*!< principal widget */
    horizontalLayoutWidgetctin1 = new QWidget(centralWidget);   /*!< horizontalLayoutWidgetctin1  QWidget */
    horizontalLayoutWidgetctin1->setGeometry(QRect(10, 10, 540,41)); /*!< size of the Widget */
    horizontalLayoutctin1 = new QHBoxLayout(horizontalLayoutWidgetctin1); /*!< horizontalLayoutctin1 QHBoxLayout */
    horizontalLayoutctin1->setSpacing(6); 
    horizontalLayoutctin1->setMargin(11);
    horizontalLayoutctin1->setContentsMargins(0, 0, 0, 0);
    
    labelctin1 = new QLabel("Module Entree:", horizontalLayoutWidgetctin1); /*!< labelctin1  QLabel */
    horizontalLayoutctin1->addWidget(labelctin1);    /*!< added labelctin1 */
   
    comboBoxctin1 = new QComboBox(horizontalLayoutWidgetctin1); /*!< comboBoxctin1 QComboBox */
     comboBoxctin1  ->setEditable(true); 
     comboBoxctin1   ->addItem("");
     comboBoxctin1   ->addItem("");
     comboBoxctin1   ->addItem("");
     comboBoxctin1   ->addItem("");
    horizontalLayoutctin1->addWidget(comboBoxctin1); /*!< added comboBoxctin1 */

    labelctin3 = new QLabel("   Nombre Entree:", horizontalLayoutWidgetctin1); /*!< labelctin QLabel */
    horizontalLayoutctin1->addWidget(labelctin3); /*!< added labelctin3 */

    comboBoxctin2 = new QComboBox(horizontalLayoutWidgetctin1); /*!< QcomboBoxctin for input insertion */
     comboBoxctin2  ->setEditable(true);
     comboBoxctin2   ->addItem("");
     comboBoxctin2   ->addItem("");
     comboBoxctin2   ->addItem("");
     comboBoxctin2   ->addItem("");
    horizontalLayoutctin1->addWidget(comboBoxctin2); /*!< added comboBoxctin2 */

    labelctin2 = new QLabel("      Choix interval", horizontalLayoutWidgetctin1); /*!< QLabel for choix interval */
     horizontalLayoutctin1->addWidget(labelctin2);       /*!< added labelctin2 */
    fontComboBoxctin1 = new QComboBox(horizontalLayoutWidgetctin1); /*!< QComboBox for fontComboBoxctin1 */
     fontComboBoxctin1  ->setEditable(true); 
     fontComboBoxctin1   ->addItem("");
     fontComboBoxctin1   ->addItem("");
     fontComboBoxctin1   ->addItem("");
     fontComboBoxctin1   ->addItem("");
    horizontalLayoutctin1->addWidget(fontComboBoxctin1); /*!< added fontComboBoxctin1 */
//------------------------------------------------------------------------------------------
    formLayoutWidgetctin1 = new QWidget(centralWidget);  /*!< QWidget for formLayoutWidgetctin1 */
    formLayoutWidgetctin1->setGeometry(QRect(150, 111, 140, 100));   /*!< set size of formLayoutWidgetctin1 */
    formLayoutctin1 = new QFormLayout(formLayoutWidgetctin1);  /*!< QFormLayout for formLayoutctin1 */
    formLayoutctin1->setSpacing(6);
    formLayoutctin1->setMargin(11);
    formLayoutctin1->setContentsMargins(0, 0, 0, 0);
    //labelctin4 = new QLabel(formLayoutWidgetctin1);
    

    //lineEditctin1 = new QLineEdit(formLayoutWidgetctin1);
    comboBoxctin_i = new QComboBox(formLayoutWidgetctin1); /*!< QComboBox for comboBoxctin_i */
     comboBoxctin_i  -> setEditable(true);
     comboBoxctin_i  ->addItem("0"); /// le zero par defaut est ici
     comboBoxctin_i  ->addItem("");
     comboBoxctin_i  ->addItem("");
     comboBoxctin_i  ->addItem("");

    comboBoxctin_j = new QComboBox(formLayoutWidgetctin1);  /*!< QComboBox for comboBoxctin_j */
     comboBoxctin_j  ->setEditable(true);
     comboBoxctin_j  ->addItem("");
     comboBoxctin_j  ->addItem("");
     comboBoxctin_j  ->addItem("");
     comboBoxctin_j  ->addItem("");  
   
   // formLayout->setWidget(1, QFormLayout::FieldRole, lineEdit_2);

    //lineEditctin3 = new QLineEdit(formLayoutWidgetctin1);
    comboBoxctin_k = new QComboBox(formLayoutWidgetctin1); /*!< QComboBox for comboBoxctin_k */
     comboBoxctin_k  ->setEditable(true);
     comboBoxctin_k  ->addItem("");
     comboBoxctin_k  ->addItem("");
     comboBoxctin_k  ->addItem("");
     comboBoxctin_k  ->addItem("");
     
    comboBoxctin_t = new QComboBox(formLayoutWidgetctin1);  /*!< QComboBox for comboBoxctin_t */
     comboBoxctin_t  ->setEditable(true);
     comboBoxctin_t  ->addItem("");
     comboBoxctin_t  ->addItem("");
     comboBoxctin_t  ->addItem("");
     comboBoxctin_t  ->addItem("");

    formLayoutctin1->addRow("i: ",  comboBoxctin_i); /*!< added comboBoxctin_i */
    formLayoutctin1->addRow("j: ",  comboBoxctin_j);  /*!< added comboBoxctin_j */
    formLayoutctin1->addRow("k:",  comboBoxctin_k);   /*!< added comboBoxctin_k */
    formLayoutctin1->addRow("t:",  comboBoxctin_t);  /*!< added comboBoxctin_t */
//----------------------------------------------------------------------------------------------------------     
    formLayoutWidgetctin2 = new QWidget(centralWidget);   /*! QWidget for formLayoutWidgetctin2 */ 
    formLayoutWidgetctin2->setGeometry(QRect(310, 120, 169, 120)); /*!< set size formLayoutctin2 */
    formLayoutctin2 = new QFormLayout(formLayoutWidgetctin2);     /*!< QFormLayout for formLayoutctin2 */
    formLayoutctin2->setSpacing(6);
    formLayoutctin2->setMargin(11);
    formLayoutctin2->setContentsMargins(0, 0, 0, 0);
    labelctin7 = new QLabel(formLayoutWidgetctin2); /*!< QLabel for labelctin7 */
    
    //formLayoutctin2->setWidget(0, QFormLayout::LabelRole, label_7);

    labelctin8 = new QLabel(formLayoutWidgetctin2);   /*!< QLabel for labelctin8 */
    //formLayout_2->setWidget(1, QFormLayout::LabelRole, label_8);

    labelctin9 = new QLabel(formLayoutWidgetctin2);   /*!< QLabel for labelctin9 */
    //formLayout_2->setWidget(2, QFormLayout::LabelRole, label_9);

   
    radioButtonctin1 = new QRadioButton(formLayoutWidgetctin2);  /*!< QRadioButton  for radioBUttonctin1 */
    //formLayout_2->setWidget(0, QFormLayout::FieldRole, radioButton);

    radioButtonctin2 = new QRadioButton(formLayoutWidgetctin2);  /*!< QRadioButton  for radioBUttonctin2 */

    radioButtonctin3 = new QRadioButton(formLayoutWidgetctin2);  /*!< QRadioButton  for radioBUttonctin3 */
    radioButtonctin4 = new QRadioButton(formLayoutWidgetctin2);  /*!< QRadioButton  for radioBUttonctin4 */
         
    formLayoutctin2->addRow("Absolue: ",  radioButtonctin1); /*!< added radioBUttonctin1 */
    formLayoutctin2->addRow("Absolue: ",  radioButtonctin2);  /*!< added radioBUttonctin2 */ 
    formLayoutctin2->addRow("Absolue:",  radioButtonctin3);   /*!< added radioBUttonctin3 */
    formLayoutctin2->addRow("Absolue:",  radioButtonctin4);   /*!< added radioBUttonctin4 */
    formLayoutWidgetctin3 = new QWidget(centralWidget);   /*!< QWidget formLayoutWidgetctin3 */
//-----------------------------------------------------------------------------------------------------
    //formLayoutWidget_3->setObjectName(QString::fromUtf8("formLayoutWidget_3"));
    formLayoutWidgetctin3->setGeometry(QRect(75, 250, 550, 191));  /*!< set size formLayoutWidgetctin3 */ 
    formLayoutctin3 = new QFormLayout(formLayoutWidgetctin3); /*!< QFormLayout for formLayoutctin3 */ 
    formLayoutctin3->setSpacing(6);
    formLayoutctin3->setMargin(11);
    //formLayoutctin3->setObjectName(QString::fromUtf8("formLayout_3"));
    formLayoutctin3->setContentsMargins(0, 0, 0, 0);

    tableWidgetctin1 = new QTableWidget(0, 8, formLayoutWidgetctin3);  /*!< QTableWidget for tableWidgetctin1 */
    tableWidgetctin1->setEditTriggers(QAbstractItemView::NoEditTriggers); /*!< this ligne give no edit mode*/
    tableWidgetctin1->setShowGrid(false); /*!< this ligne cover the grille in table */
    tableWidgetctin1->setSelectionBehavior(QAbstractItemView::SelectRows); /*!< this ligne give a section of the ligne */
   //--------------------------------------------------------------
    QStringList horizontalHeaders;
    horizontalHeaders << "Entree" << "No Entrees" << "Sortie" << "No Sorties" << "i" << "j" << "k" << "t"; /*!< added Nom Netward Entrees and sorties in table */
    tableWidgetctin1->setHorizontalHeaderLabels(horizontalHeaders); 

    formLayoutctin3->addRow(tableWidgetctin1);   /*!< displays the QTableWidget */
    
    m_AjoutCtin                 = new QPushButton("Ajouter", centralWidget); /*!< The button "add". */
    m_AjoutCtin -> setGeometry(630, 270, 65, 23);  /*!< set size m_AjoutCtin */

    //  connect(m_quitCtin, SIGNAL(clicked()), this, SLOT(close()));
//-----------------------------------------------------------------------------------------------------------------
    horizontalLayoutWidgetctin2 = new QWidget(centralWidget); /*!< QWidget for horizontalLayoutWidgetctin2 */ 
    //horizontalLayoutWidgetctin2->setObjectName(QString::fromUtf8("horizontalLayoutWidget_2"));
    horizontalLayoutWidgetctin2->setGeometry(QRect(170, 430, 400, 80)); /*!< set size horizontalLayoutWidgetctin2 */
    horizontalLayoutctin2 = new QHBoxLayout(horizontalLayoutWidgetctin2); /*!< QHBoxLayout  horizontalLayoutctin2 */ 
    horizontalLayoutctin2->setSpacing(6);
    horizontalLayoutctin2->setMargin(11);
    //horizontalLayoutctin2->setObjectName(QString::fromUtf8("horizontalLayout_2"));
    horizontalLayoutctin2->setContentsMargins(0, 0, 0, 0);
    pushButtonctin3 = new QPushButton("Enregistrer", horizontalLayoutWidgetctin2); /*!< QPushButton Enregistrer */
    //-------------------------------------------------
     m_AideCtin                 = new QPushButton("De l'aide?", centralWidget);  /*!< The button "Aide". */
    //m_AideTraj -> setGeometry(635, 280, 65, 23);  /*!< set size button  */
    //m_AideCtin -> setGeometry(635, 10, 40, 23);  /*!< set size button  */
    m_AideCtin -> setGeometry(10, 280, 60, 23);  /*!< set size button  */
    pushButtonctin2                  = new QPushButton("Supprimer", centralWidget);  /*!< The button "Supprimer". */
    pushButtonctin2 -> setGeometry(630, 300, 65, 23); /*!< set size button */ 

    horizontalLayoutctin2->addWidget(pushButtonctin3);  /*!< added pushButtontctin3 */

   // pushButtonctin2 = new QPushButton("Supprimer", horizontalLayoutWidgetctin2);  /*!< QPushButton Supprimer */
    //pushButtonctin2->setObjectName(QString::fromUtf8("pushButton_2"));

   // horizontalLayoutctin2->addWidget(pushButtonctin2);    /*!< added pushButtontctin2 */

    pushButtonctin1 = new QPushButton("Quitter", horizontalLayoutWidgetctin2); /*!< QPushButton Quitter */
    //pushButton->setObjectName(QString::fromUtf8("pushButton"));

    horizontalLayoutctin2->addWidget(pushButtonctin1);   /*!< added pushButtonctin1 */
//-----------------------------------------------------------------------------------------------------------
    horizontalLayoutWidgetctin3 = new QWidget(centralWidget);  /*!< QWidget for horizontalLayoutWidgetctin3 */
    //horizontalLayoutWidgetctin3->setObjectName(QString::fromUtf8("horizontalLayoutWidget_3"));
    horizontalLayoutWidgetctin3->setGeometry(QRect(10, 60, 540, 41));  /*!< set size  horizontalLayoutWidgetctin3 */ 
    horizontalLayoutctin3 = new QHBoxLayout(horizontalLayoutWidgetctin3); /*!  QHBoxLayout for horizontalLayoutctin3 */
    horizontalLayoutctin3->setSpacing(6);
    horizontalLayoutctin3->setMargin(11);
    //horizontalLayoutctin3->setObjectName(QString::fromUtf8("horizontalLayout_3"));
    horizontalLayoutctin3->setContentsMargins(0, 0, 0, 0);
    

    labelctin10 = new QLabel("Module Sortie:", horizontalLayoutWidgetctin3);  /*!< QLabel for labelctin10 "Module Sortie" */
    horizontalLayoutctin3->addWidget(labelctin10);  /*!< added labelctin10 */
    comboBoxctin4 = new QComboBox(horizontalLayoutWidgetctin3); /*!< QComboBox for comboBoxctin4 */
     comboBoxctin4  ->setEditable(true);
     comboBoxctin4   ->addItem("");
     comboBoxctin4   ->addItem("");
     comboBoxctin4   ->addItem("");
     comboBoxctin4   ->addItem("");

    horizontalLayoutctin3->addWidget(comboBoxctin4);  /*!< added comboBoxctin4 */

    labelctin12 = new QLabel("   Nombre Sortie:", horizontalLayoutWidgetctin3); /*!< labelctin12 for Nombre Sortie */
    horizontalLayoutctin3->addWidget(labelctin12);  /*!< added labelctin12 */

    comboBoxctin3 = new QComboBox(horizontalLayoutWidgetctin3);  /*!< QComboBox for comboBoxctin3 */
     comboBoxctin3  ->setEditable(true);
     comboBoxctin3   ->addItem("");
     comboBoxctin3   ->addItem("");
     comboBoxctin3   ->addItem("");
     comboBoxctin3   ->addItem("");
    //comboBox_3->setObjectName(QString::fromUtf8("comboBox_3"));

    horizontalLayoutctin3->addWidget(comboBoxctin3); /*!< added comboBoxctin3 */

    labelctin11 = new QLabel("      Choix Interval", horizontalLayoutWidgetctin3);  /*!< QLabel for labelctin11 "Choix Interval" */
    horizontalLayoutctin3->addWidget(labelctin11); /*!< added labelctin11 */
    fontComboBoxctin2 = new QComboBox(horizontalLayoutWidgetctin3);
     fontComboBoxctin2  ->setEditable(true);
     fontComboBoxctin2   ->addItem("");
     fontComboBoxctin2   ->addItem("");
     fontComboBoxctin2   ->addItem("");
     fontComboBoxctin2   ->addItem("");
    //fontComboBoxctin2->setObjectName(QString::fromUtf8("fontComboBox_2"));
     horizontalLayoutctin3->addWidget(fontComboBoxctin2); /*!< added  fontComboBoxctin2 */

         connect(pushButtonctin1, SIGNAL(clicked()), this, SLOT(close()));       /*!< slot for the close this windows*/
         connect(pushButtonctin2, SIGNAL(clicked()), this, SLOT(appelSupp()));  /*!< slot  for the delete the object selected in the view*/
         connect(m_AjoutCtin, SIGNAL(clicked()), this, SLOT(appelAjoutCtin())); /*!< This slot add the object in the view */ 
          connect(m_AideCtin, SIGNAL(clicked()), this, SLOT(callCtinHelp()));   /*!< This slot opens */
          


  }
/**************************************** This function add the object in the view*************************************/
/****************************************************************************************/
void CtinWindow::appelAjoutCtin() {

 static int row = 0;
  int l = 0;
  QString texte = " from ";

QString comboline1 = comboBoxctin1->currentText();
QString comboline2 = comboBoxctin2->currentText();
QString comboline3 = comboBoxctin3->currentText();
QString comboline4 = comboBoxctin4->currentText();
//QString comboline5 = comboBoxctin1->currentText();
//QString comboline1 = comboBoxctin1->currentText();


             for(int i = 0; i<comboline1.size(); i++)
        //if (m_ligneNomTraj->text().isEmpty())
     if(!((comboline1.at(i) >= QChar('a')&& comboline1.at(i) <= QChar('z')) || (comboline1.at(i) >= QChar('A')&& comboline1.at(i) <= QChar('Z')) //--------
         || (comboline1.at(i) >= QChar('0')&& comboline1.at(i) <= QChar('9')) || (comboline1.at(i) == QChar('_')))) //|| (line1.isEmpty())
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte pour le module entre1");
        return; // Arrêt de la méthode
    }
       for(int i1 = 0; i1<comboline2.size(); i1++)
        //if (m_ligneNomTraj->text().isEmpty())
     if(!((comboline2.at(i1) >= QChar('0')&& comboline2.at(i1) <= QChar('9')))) //|| (line1.isEmpty())
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte pour le module entre 2");
        return; // Arrêt de la méthode
    }
       for(int i3 = 0; i3<comboline3.size(); i3++) 
     if(!((comboline3.at(i3) >= QChar('0')&& comboline3.at(i3) <= QChar('9')))) //||
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte pour le module sortie 2");
        return; // Arrêt de la méthode
    }
       for(int i4 = 0; i4<comboline4.size(); i4++)
     if(!((comboline4.at(i4) >= QChar('a')&& comboline4.at(i4) <= QChar('z')) || (comboline4.at(i4) >= QChar('A')&& comboline4.at(i4) <= QChar('Z'))
         || (comboline4.at(i4) >= QChar('0')&& comboline4.at(i4) <= QChar('9')) || (comboline4.at(i4) == QChar('_')))) //|| 
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte pour le module sortie 1");
        return; // Arrêt de la méthode
    }
       
 
       if ((comboBoxctin1->currentText().isEmpty()) || (comboBoxctin2->currentText().isEmpty()) || (comboBoxctin3->currentText().isEmpty()) || (comboBoxctin4->currentText().isEmpty()) || (comboBoxctin_i->currentText().isEmpty()))
        {
    QMessageBox::critical(this, "Erreur", "Il y a au moins un module d'entree non definie: entrer la valeur manquante SVP!!!!");
        return; // Arrêt de la méthode
    }

       else if ((comboBoxctin3->currentText().isEmpty()) || (comboBoxctin4->currentText().isEmpty()))
        {
    QMessageBox::critical(this, "Erreur", "Il y a au moins un module de sortie non definie: entrer la valeur manquante SVP!!!!");
        return; // Arrêt de la méthode
    }
       else if (comboBoxctin_i->currentText().isEmpty())
        {
    QMessageBox::critical(this, "Erreur", "La valeur de l'axe i est vide: entrer la valeur manquante SVP!!!!");
        return; // Arrêt de la méthode
    }

if (l >= 0)
{
     

      tableWidgetctin1->setItem(row, 0, new QTableWidgetItem(comboBoxctin1->currentText()));
      tableWidgetctin1->setItem(row, 1, new QTableWidgetItem(comboBoxctin2->currentText()));
      tableWidgetctin1->setItem(row, 2, new QTableWidgetItem(comboBoxctin4->currentText()));
      tableWidgetctin1->setItem(row, 3, new QTableWidgetItem(comboBoxctin3->currentText()));
      tableWidgetctin1->setItem(row, 4, new QTableWidgetItem(comboBoxctin_i->currentText()));
      tableWidgetctin1->setItem(row, 5, new QTableWidgetItem(comboBoxctin_j->currentText()));
      tableWidgetctin1->setItem(row, 6, new QTableWidgetItem(comboBoxctin_k->currentText()));

          CtinData.push_back(comboBoxctin1->currentText() + " " + comboBoxctin2->currentText() + texte + comboBoxctin4->currentText() +
                                                          " " + comboBoxctin3->currentText() + " " + comboBoxctin_i->currentText() +
                                                          " " + comboBoxctin_j->currentText() + " " + comboBoxctin_k->currentText() +
                                                          " " + comboBoxctin_t->currentText()); 
    row++;
//}
        }
//writefileCtin();
  initialiseCtin();

}
/****************************************************************************************/
void CtinWindow::appelSupp() {

                 tableWidgetctin1->removeRow(tableWidgetctin1->currentRow());

               }

//******************************* Write in the .d file**********************************/

/*void CtinWindow::writefileCtin(){

         CtinData.push_back(comboBoxctin1->currentText() + " " + comboBoxctin2->currentText() + " " + comboBoxctin4->currentText() +
                                                          " " + comboBoxctin3->currentText() + " " + comboBoxctin_i->currentText() +
                                                          " " + comboBoxctin_j->currentText() + " " + comboBoxctin_k->currentText()); 
  

                            }*/
/****************************************************************************************************************************/
QStringList CtinWindow::getDataCtin() {

    
     return CtinData;
}

//****************************************************************************************/

void CtinWindow::initialiseCtin() {
                 
	comboBoxctin1->clearEditText();
        comboBoxctin2->clearEditText();
	comboBoxctin3->clearEditText();
        comboBoxctin4->clearEditText();
	//comboBoxctin_i->clearEditText();
	comboBoxctin_j->clearEditText();
	comboBoxctin_k->clearEditText();

}
//****************************************************************************************/
void CtinWindow::callCtinHelp() {

  QMessageBox::about(this, tr("Aide sur la directive Ctin."),("<p> Cette directive sert à établir des connections, "
                              "entre les entrées et sorties des modules meme si ceux-ci appartiennent à des espaces "
                              "differents rattachés meme à des trajectoires differentes. <p>Les parametres à "
                              "préciser sont les suivants : <br>nom modul  entree sortie range_i range_j range_k"
                              "range_t." 
                              "<br> <a href=\"help/ctin_aide.html\">lien HTML Cliquez ici SVP !</a>"));

}

/****************************************************************************************/
