//! \file    DefvalWindow.cpp
//! \brief   Implementation of the Defval window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

/*
  Nom du Fichier: DefvalWindow.cpp
  Nom de classe: DefvalWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include <iostream>
#include "Include/DefvalWindow.hpp"
//! \class DefvalWindow(QWidget *parent): QWidget(parent);
//! \brief Implementation of the Defval window for visual_YAO.

using namespace std;

/***************************************** The constructor **********************************************************************/

DefvalWindow::DefvalWindow(QWidget *parent): QWidget(parent) {  /*!< The constructor. */
	
        this->setWindowTitle("Directive Defval.");     /*!< To set the window's title. */
        isCalled = false;
  // Instanciation des classes.
	// Déclaration des boutons et champs de saisie de texte.
	m_ligneNomDefval 	= new QLineEdit(this) ;    /*!< Name of the QLineEdit. */
        m_ligneValeurDefval	= new QLineEdit(this) ;   /*!< Value of the QLineEdit. */
	
        m_ajoutDefval		= new QPushButton("Ajouter", this);   /*!< QPushButton for Ajout. */
        m_DefvalHelpButton      = new QPushButton("De l'aide ?");   /*!< QPushButton for aide. */
        m_supDefval		= new QPushButton("Supprimer", this);  /*!< QPushButton for Supprimer. */
		m_supDefval->setDisabled(true);	  /*!< setDisabled is true. */
	m_saveDefvalButton	= new QPushButton("Enregistrer", this);   /*!< QPushButton for Enregistrer. */
               // m_saveDefvalButton->setDisabled(true);
        m_quitDefval		= new QPushButton("Quitter", this);   /*!< QPushButton for Quitter. */

	vueDefval 		= new QTableWidget(0, 3);  /*!< QTableWidget's in whitch the objects are listed for thue view. */

        //Les gestionnaires de positionnement.
	m_layoutGDefval		= new QGridLayout;  /*!< set QGridLayout m-layoutGDefval */
		m_layoutGDefval->addWidget(m_DefvalHelpButton, 1, 1); /*!<  m_DefvalHelpButton in the QGridLayout */
		m_layoutGDefval->addWidget(vueDefval, 0, 2, 4, 2); /*!< added m_vueDefval in the QGridLayout */
		m_layoutGDefval->addWidget(m_ajoutDefval, 1, 4);  /*!< added m_ajoutDefval in the QGridLayout */
		m_layoutGDefval->addWidget(m_supDefval, 2, 4); /*!< added m_supDefval in the QGridLayout */
		//m_layoutGDefval->addLayout(m_layoutH1Defval, 7, 2, 1, 2);  /*!< added m_saveDefvalButton in the QGridLayout */
	m_layoutH1Defval        = new QHBoxLayout;
		m_layoutH1Defval->setAlignment(Qt::AlignCenter);
		m_layoutH1Defval->addWidget(m_saveDefvalButton);
                m_layoutH1Defval->addWidget(m_quitDefval);//m_ajoutDefval);
	m_layoutFDefval		= new QFormLayout ;
		m_layoutFDefval->setAlignment(Qt::AlignCenter);
                m_layoutFDefval->addRow("Nom de la constante:", m_ligneNomDefval);
                m_layoutFDefval->addRow("Valeur de la constante:", m_ligneValeurDefval);
	m_groupBox1		= new QGroupBox;
		m_groupBox1->setLayout(m_layoutFDefval);
	m_groupBox2		= new QGroupBox;
		m_groupBox2->setLayout(m_layoutGDefval);
	
	//m_labelNomDefval	= new QLabel("Nom de la constante: ");    /*!< QLabel for Nom de la constante . */
	//m_labelValeurDefval	= new QLabel("Valeur de la constante: ");  /*!< QLabel for Valeur de la constante. */
       
                //m_quitDefval->setDefault(true);
                //m_quitDefval->setDisabled(true);
        
        vueDefval->setEditTriggers(QAbstractItemView::NoEditTriggers); /*!< this ligne give no edit mode*/
        vueDefval->setShowGrid(false);  /*!< this ligne cover the grille in table */
        vueDefval->setSelectionBehavior(QAbstractItemView::SelectRows);  /*!< this ligne give a section of the ligne */


        QStringList horizontalHeaders;
    		horizontalHeaders << "Constante(s)"  << "Valeur(s)" << " ";  /*!< added Nom Netward Entrees and sorties in table */
   	vueDefval->setHorizontalHeaderLabels(horizontalHeaders); /*!< displays the QTableWidget */

        index = vueDefval->currentIndex();

        m_modeleListeNoms       = new QStringListModel(m_listeNomsDefval);

	// Insertion des tous widgets dans le gestionnaire principal.
	m_layoutPrincipalDefval = new QVBoxLayout; //Déclaration du gestionnaire principal.
		m_layoutPrincipalDefval->addWidget(m_groupBox1);
		m_layoutPrincipalDefval->addWidget(m_groupBox2);
		m_layoutPrincipalDefval->addLayout(m_layoutH1Defval);
	this->setLayout(m_layoutPrincipalDefval); //Activation du gestionnaire principal.
        
   	// Gestion des connexions entre les widgets.
        connect(m_quitDefval, SIGNAL(clicked()), this, SLOT(close()));  /*!< slot for the close this windows*/
        connect(m_supDefval, SIGNAL(clicked()), this, SLOT(deleteDefvalRow())); /*!< To delete the object selected in the view*/
        connect(m_ajoutDefval, SIGNAL(clicked()), this, SLOT(addDefvalRow()));  /*!< This slot add the object in the view */
        connect(m_DefvalHelpButton, SIGNAL(clicked()), this, SLOT(callDefvalHelp())); /*!< This slot opens the help window */
	connect(m_saveDefvalButton, SIGNAL(clicked()), this, SLOT(saveDefvalData())); /*!< This slot save data in structure */
 
    	

}
/****************************************** addDefvalRow() method **********************************************/
void DefvalWindow::addDefvalRow() {

	addRow();
                static int i = 1;
                static int j = 1;
	QString NomDefval = m_ligneNomDefval->text();
	QString ValDefval = m_ligneValeurDefval->text();

       
         for(int i1 = 0; i1 < NomDefval.size(); i1++)
        //if (m_ligneNomTraj->text().isEmpty())
     if(!((NomDefval.at(i1) >= QChar('a')&& NomDefval.at(i1) <= QChar('z')) || (NomDefval.at(i1) >= QChar('A')&& NomDefval.at(i1) <= QChar('Z')) //--------
         || (NomDefval.at(i1) >= QChar('0')&& NomDefval.at(i1) <= QChar('9')) || (NomDefval.at(i1) == QChar('_')))) //|| (line1.isEmpty())
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur exacte du nom de la constante.");
        return; // Arrêt de la méthode
    }
       for(int i2 = 0; i2 < ValDefval.size(); i2++)
        //if (m_ligneNomTraj->text().isEmpty())
     if(!((ValDefval.at(i2) >= QChar('a') && ValDefval.at(i2) <= QChar('z')) || (ValDefval.at(i2) >= QChar('A')&& ValDefval.at(i2) <= QChar('Z')) 
	||(ValDefval.at(i2) >= QChar('0') && ValDefval.at(i2) <= QChar('9')) || (ValDefval.at(i2) == QChar('_')) || (ValDefval.at(i2) == QChar('-')) || (ValDefval.at(i2) == QChar('E')) || (ValDefval.at(i2) == QChar('e')) || (ValDefval.at(i2) == QChar('+')) || (ValDefval.at(i2) == QChar('.')))) //|| (line1.isEmpty())
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte pour la constante.");
        return; // Arrêt de la méthode
    }

       if ( m_ligneNomDefval->text().isEmpty())
        {
    QMessageBox::critical(this, "Erreur", "Le champ du nom de la constante est vide: entrer un nom SVP!");
        return; // Arrêt de la méthode
    }

        if ((i!=0)&&(j!=0)) {

            if (isCalled) {--i ; isCalled = false; }
           addNameInTable(i, j, m_ligneNomDefval->text());
           m_listeNomsDefval.append(m_ligneNomDefval->text() + " " + m_ligneValeurDefval->text());
           addValueInTable(i, j, m_ligneValeurDefval->text());
           //m_listeValeursDefval.append(m_ligneNomDefval->text());

           //DefvalData.push_back(m_ligneNomDefval->text() + " " + m_ligneValeurDefval->text()); 

            i++;
        }

    m_supDefval->setEnabled(true);
    initialiserChamps();


}
/************************************ deleteDefvalRow() method ****************************************************/
void DefvalWindow::deleteDefvalRow() {

	vueDefval->removeRow(vueDefval->currentRow());
    	isCalled = true;

}

/****************************************************************************************/
void DefvalWindow::addNameInTable(int ligne, int colonne, QString nomDefval) {
    QTableWidgetItem *chaine = new QTableWidgetItem;
    chaine->setText(nomDefval);

      vueDefval->setItem(ligne-1, colonne-1, new QTableWidgetItem(nomDefval));
}

/****************************************************************************************/
void DefvalWindow::addValueInTable(int ligne, int colonne, QString valeurDefval) {

QTableWidgetItem *chaine = new QTableWidgetItem;
chaine->setText(valeurDefval);

    vueDefval->setItem(ligne - 1, colonne, chaine);

}

/****************************************************************************************/
void DefvalWindow::addRow() {

	int row = vueDefval->rowCount();
	vueDefval->insertRow(row);

}
/****************************************************************************************/
void DefvalWindow::saveDefvalData() {

	QTableWidgetItem *cell1 = new QTableWidgetItem;
	QTableWidgetItem *cell2 = new QTableWidgetItem;	
	
	for (int i = 0; i < vueDefval->rowCount() ; i++) {
			cell1 = vueDefval->item(i,0);
			cell2 = vueDefval->item(i,1);
				
			defvalData.push_back(cell1->text() + " " + cell2->text());
         		
		}
	//for (QStringList::iterator it = defvalData.begin(); it != defvalData.end(); it++)
	//cout << "Voici les valeurs ajoutées: " << it->toStdString() <<endl;
    m_quitDefval->setEnabled(true);

}
/****************************************************************************************/
void DefvalWindow::initialiserChamps() {

     	   m_ligneNomDefval->setText("");
	   m_ligneValeurDefval->setText("");
}

/************************************ Implémentation de la méthode callHelpDefval ****************************************/
void DefvalWindow::callDefvalHelp()
{
    QMessageBox::about(this, tr("Aide sur la directive defval."),("<p> La directive defval permet (a l'instar de la directive #define de c/c++) d'associer un nom symbolique a une valeur."
                                                                  "<p><u>Exemple 1</u>: deval szx 12 <p><u>Exemple 2</u>: defval szy \"chaine\"<p> <u>Exemple 3</u>: defval szz szx"
                                                                  "<br> <a href=\"help/defval_aide.html\">lien HTML Cliquez ici SVP !</a>"));
}

/****************************************************************************************/
void DefvalWindow::ouvrirProjetExistant() {

  fd = new QFileDialog(this);
  QStringList filtres;

  fd->setDirectory(".");
  fd->setFileMode (QFileDialog::AnyFile);
  filtres << "*.*"
          << "Tous les fichiers (*.*)";
  fd->setFilters(filtres);

     lstF = fd->getSaveFileName();
}
/****************************************************************************************************************************/
QStringList DefvalWindow::getDataDefval() {

    
     return defvalData;
}

/****************************************************************************************/
/*void DefvalWindow::fermerEnrDef()
{
bool tar;
     // if ((m_quit->pressed()) && (m_enreg->pressed()))
      if(m_supDefval->setEnabled(true))
    {
        close();
    }
    else {
        QMessageBox::critical(this, "Erreur", "Voullez vous enregistrer avant de Quitter !!!");
        return; // Arrêt de la méthode 
    }
 //closeEvent(QCloseEvent *event);
}*/
/************************************************************************************/
/*bool DefvalWindow::enregDataDefval(bool tar) {

    
     saveDefvalData();//return defvalData;
      return tar;
}*/
/********************************************************************************/


