/*!
 * \file    CtinWindow.hpp
 * \brief   Ctin class for visual_YAO.
 * \version 2009/11/09 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane & MAYOMBO Alexis.
 */


#ifndef CTIN_HPP
#define CTIN_HPP
#include <QWidget>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QLineEdit>
#include <QFormLayout>
#include <QButtonGroup>
#include <QComboBox>
#include <QFontComboBox>
#include <QFormLayout>
#include <QHBoxLayout>
#include <QMainWindow>
#include <QRadioButton>
#include <QTableWidget>
#include <QStringList>
#include <QStandardItemModel>
#include <string>
#include <iostream>
#include <fstream>
#include <QFileDialog>
#include <QMessageBox>

//using namespace yao;
using namespace std;

/*!
 * \class CtinWindow
 * \brief Ctin class for visual_YAO.
 */

class CtinWindow : public QWidget {


               Q_OBJECT

    public :
    /*!
     *  \brief Constructor
     *
     *  Constructor of the class CtinWindow
     *
     *  \param parent : initialized at zero.
     */
            CtinWindow(QWidget *parent=0);
            //void writefileCtin();
             QStringList getDataCtin(); /*!< This function returns the connexion's data. */
             void initialiseCtin();  

    private slots:       /*!< Functions called after a click. */
           
            void appelAjoutCtin();   /*!< This function is called to add row in the visual window model. */
            void appelSupp();  /*!< This function is called to delete row from the Yao model. */
            void callCtinHelp();

    private :
              
    QWidget *centralWidget;
    QWidget *horizontalLayoutWidgetctin1;
    QHBoxLayout *horizontalLayoutctin1;
    QLabel *labelctin2;
    QLabel *labelctin1;
    QComboBox *comboBoxctin1;              /*!< ComboBox for the Modul of entred */
    QLabel *labelctin3;
    QComboBox *comboBoxctin2;  /*!< Input */
    QComboBox *fontComboBoxctin1;
    QWidget *formLayoutWidgetctin1;
    QFormLayout *formLayoutctin1;
    QLabel *labelctin4;
    //QLineEdit *lineEditctin1;
    QComboBox *comboBoxctin_i;
    QLabel *labelctin5;
    QLabel *labelctin6;
    //QLineEdit *lineEditctin2;
    QComboBox *comboBoxctin_j; 
    //QLineEdit *lineEditctin3;
    QComboBox *comboBoxctin_k;
    QComboBox *comboBoxctin_t; /////
    QWidget *formLayoutWidgetctin2;
    QFormLayout *formLayoutctin2;
    QLabel *labelctin7;
    QLabel *labelctin8;
    QLabel *labelctin9;
    QRadioButton *radioButtonctin1;
    QRadioButton *radioButtonctin2;
    QRadioButton *radioButtonctin3;
    QRadioButton *radioButtonctin4; 
    QWidget *formLayoutWidgetctin3;
    QFormLayout *formLayoutctin3;
    QTableWidget *tableWidgetctin1;
    QWidget *horizontalLayoutWidgetctin2;
    QHBoxLayout *horizontalLayoutctin2;
    QPushButton *pushButtonctin3;
    QPushButton *pushButtonctin2;
    QPushButton *pushButtonctin1;
    QWidget *horizontalLayoutWidgetctin3;
    QHBoxLayout *horizontalLayoutctin3;
    QLabel *labelctin11;
    QLabel *labelctin10;
    QComboBox *comboBoxctin4;
    QLabel *labelctin12;
    QComboBox *comboBoxctin3;
    QComboBox *fontComboBoxctin2;
    QPushButton *m_AjoutCtin;
    QStringList CtinData;
    QComboBox *comboBoxFrom; 
    QPushButton *m_AideCtin;
    //QLineEdit *m_ligneTypeCtin;  

};
#endif // CTIN_HPP
