#ifndef HATNAME_HPP
#define HATNAME_HPP

#include <QVBoxLayout>
#include <QPushButton>
#include <QFormLayout>
#include <QLineEdit>
#include <QListView>
#include <QStandardItemModel>
#include <QTableWidget>
#include <QMessageBox>
#include <QFileDialog>
#include <QLabel>
#include <QStringListModel>
#include <QComboBox>
#include <QStringList>
#include <QSpacerItem>
#include <string>
#include <QGridLayout>

//#include "MainWindowController.hpp"
#include "../../../help/FilePath.hpp"
//#include "../../../help/Enforcer.hpp"

//class NewProjectWindow

/*!
 * \class HatNameWindow
 * \brief HatNameWindow class for visual_YAO.
 */


class HatNameWindow : public QWidget {

        Q_OBJECT;

        public :
            /*!
             *  \brief Constructor
             *
             *  Constructor of the class HatNameWindow
             *
             *  \param vector<string> * theHeaderList;
             */

            HatNameWindow(std::string param1 = "", QWidget *parent = 0);
            void setNomFichierHat(QString nomFichierHat);                       /*!< This function sets the file's name. */
            std::string getNomFichierHat();                                         /*!< This function returns the fil's name */
            void testPresenceFichier();
	    QStringList getHatName();
            void setLocalProjectName(std::string name);
            std::string getLocalProjectName();

            /*!
             *  \brief SLOT functions
             *
             *  SLOTS are (for examples) functions called after a signal emited.
             *
             *  \param vector<string> * theHeaderList;
             */

        public slots :

                void addHatRow();               /*!< This function is called to insert data in the model. */
                void deleteHatRow();            /*!< This function is called to delete data from the model. */
                void initialiserChamps();       /*!< This function is called to initialize the lineEdit. */
                //void ecrireFichier();           /*!< This function is called to write data in file model. */
                void ouvrirProjetExistant();    /*!< This function is called to open an existing project. */
                void appelEnregistrer();        /*!< This function is called to save the current project in the file model */
                void setFileList(std::string localString);
                void setTheHeaderList(std::vector<std::string> theHeaderList);

                //void setTheHeaderList(std::string theHeaderList);
                std::vector<std::string>  getTheHeaderList();
                QStringList getHatList();
                void callHatHelp();

            /*!
             *  \brief private functions
             *
             *  SLOTS are (for examples) functions called after a signal emited.
             *
             *  \param vector<string> * theHeaderList;
             */


       private :

                QLabel *m_texte;
                //QLineEdit *m_ligneNomHatName;
				QLabel *m_labelNom1HatName;
				QLabel *m_labelNom2HatName;
        
                QComboBox *m_comboHatName;

                QPushButton *m_boutonouvrir;
                QPushButton *m_enregHatName;
                QPushButton *m_supHatName;
                QPushButton *m_quitHatName;
                QPushButton *m_boutonAjouter;
                QPushButton *m_hatnameHelpButton;

                QFormLayout *m_layout1HatName;
                QSpacerItem *m_spacer;

				QHBoxLayout *m_layoutHBas;
                QHBoxLayout *m_layoutH1HatName;
                QHBoxLayout *m_layoutH2HatName;
                QHBoxLayout *m_layoutH3HatName;
                QVBoxLayout *m_layoutV1HatName;
		
				QGridLayout *m_layoutGHatName;		

                QStringList listeFichiers;
                QStringListModel *modeleFichiers;
                QListView *vueFichiers;

                QStandardItemModel *modeleHatName;

                QFileDialog *boiteDialogue;
                QModelIndex index;
                QString cheminFichier;
                std::string extension;
                std::string hatFile;
                std::vector<std::string> hatHeaderList;
                std::string localProjectName;

};
#endif
