/*!
 * \file    InsertFCTWindow.hpp
 * \brief   InsertFCT class for visual_YAO.
 * \version 2009/11/09 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane & MAYOMBO Alexis.
 */

#ifndef INSERTFCT_HPP
#define INSERTFCT_HPP
#include <QLabel>
#include <QPushButton>
#include <QWidget>
#include <QLineEdit>
#include <QHBoxLayout>
#include <QFormLayout>
#include <QCheckBox>
#include <QGroupBox>
#include <QMessageBox>
#include <QVBoxLayout>
#include <QTableWidget>
#include <QStringList>


class InsertFCTWindow : public QWidget {
    Q_OBJECT

    public :
            //string chaineDefval;
            InsertFCTWindow(QWidget *parent=0); /*!< Constructeur */
            QStringList getDataFCT();   /*!< This function returns the function's data. */
            void initialiserChampsfct();


    public slots:         /*!< Functions called after a click. */
            //void ecrireFichier();
             void appelAjoutfct();  /*!< This function is called to add row in the visual window model. */
             void appelSuppFCT();  /*!< This function is called to delete row from the Yao model. */
             void callInsertFCTHelp(); /*!< This function is called to open the help window for this parametre */
             //void fermerEnr();
    private :
            
            //QLineEdit *m_ligneNomArg;
            QLineEdit *m_ligneNomFonction; /*!< Name of the function. */
            QPushButton *m_enreg; /*!< The button Enregistrer. */
            QPushButton *m_suppfct; /*!< The button Supprimer. */
            QPushButton *m_quit; /*!< The button Quitter. */

            QFormLayout *m_layout1; /*!< QFormLayout of the m_layout1 */
            QHBoxLayout *m_layoutH; /*!< QHBoxLayout of the m_layautH */
            QVBoxLayout *m_layoutPrincipal;  /*!< QVBoxLayout of the m_layoutPrincipal*/
            //----------------------------
            QFormLayout *formLayoutArg;  /*!< QFormLayout of the formLayoutArg */
            QCheckBox *argButton; /*!< QCheckBox of the argButton */
            QGridLayout *formLayoutTab;  /*!< QGridLayout of formLayoutTab */
            QTableWidget *tableWidgetfct;   /*!< The QTableWidget of the interface . */
            //QFormLayout *formLayoutAdd;
            QHBoxLayout *layoutTabAdd;   /*!< QHBoLayout for layoutTabAdd*/
            QPushButton *m_Ajoutfct; /*!< The button "add". */
            QStringList fctData;  
            QGridLayout *m_layoutH1;
            QPushButton *m_Aidefct;


};

#endif // INSERTFCT_HPP
