#ifndef MAINWINDOWCONTROLLER_HPP
#define MAINWINDOWCONTROLLER_HPP

#include <string>
#include "../../../help/FilePath.hpp"
#include "../../../help/Enforcer.hpp"

#include "DefvalWindow.hpp"
#include "HatNameWindow.hpp"
#include "OptionWindow.hpp"
//#include "TrajController.hpp"
#include "TrajWindow.hpp"
#include "SpaceController.hpp"
#include "SpaceWindow.hpp"
#include "OperaWindow.hpp"
#include "NetwardWindow.hpp"
#include "ModulWindow.hpp"
#include "CtinWindow.hpp"
#include "OrderWindow.hpp"
#include "InsertFCTWindow.hpp"
#include "FilesViewer.hpp"
#include "NewProjectWindow.hpp"
#include "../YAOObjects/Table.hpp"



class MainWindowController {

	public :

		static MainWindowController & getInstance();
                void setDefval();
                DefvalWindow *getDefval();

                void setProjectNameInMWC(std::string projectName);
                std::string getProjectNameFromMWC();

                void setFileListController(std::string fileController);
                void setTheHeaderList(string theHeaderListSring);

                std::vector<std::string> getTheHeaderList();
                void setFileListController();

                HatNameWindow *getHatName();
                OptionWindow *getOption();
                TrajWindow *getTraj();
                SpaceWindow *getSpace();
                OperaWindow *getOpera();
                NetwardWindow *getNetward();
                ModulWindow *getModul();
                CtinWindow *getCtin();
                OrderWindow *getOrder();
                InsertFCTWindow *getInsertFCT();
                NewProjectWindow *getNewProjectInstance();
                NewProjectWindow *getNP();

                SpaceController getSpaceController();

                yao::Table<yao::Trajectory> getTheTrajectoryTable();

		
        private :

		MainWindowController() {}
                std::string m_projectNameInMWC;  // MWC = MainWindowController
                DefvalWindow *m_defval;
                HatNameWindow *m_hat;
                OptionWindow *m_option;
                TrajWindow *m_traj;
                SpaceWindow *m_space;
                SpaceController *m_spc;
                OperaWindow *m_opera;
                NetwardWindow *m_netward;
                ModulWindow *m_modul;
                CtinWindow *m_ctin;
                OrderWindow *m_order;
                InsertFCTWindow *m_insertFCT;
                FilesViewer *m_directoryViewer;
                NewProjectWindow *np;
                std::vector<std::string> m_theHeaderList;
                yao::Table<yao::Trajectory> m_theTrajectoryTable;

            };

#endif // MAINWINDOWCONTROLLER_HPP
