/*!
 * \file    Netwardwindow.hpp
 * \brief   Netward class for visual_YAO.
 * \version 2009/12/19 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane & MAYOMBO Alexis.
 */


#ifndef NETWARD_HPP
#define NETWARD_HPP
#include "src/Include/Entete.hpp"
#include <QFormLayout>
#include <QTableWidget>
#include <QGroupBox>
#include <QMessageBox>
#include <QTextStream>
#include <QModelIndex>

class NetwardWindow : public QWidget {

           Q_OBJECT;

    public :
              /*!
             *  \brief Constructor
             *
             *  Constructor of the class NetwardWindow
             *
             *  
             */
            NetwardWindow(QWidget *parent=0);  /*!< This function sets the file's name. */
            
            //--void addRowNetward();
            QStringList getDataNetward();  /*!< This function returns the netward's data. */
            void initialiserNetward();
      
    public slots :                       /*!< Functions called after a click. */
		
		void addNetwardRow();    /*!< This function is called to add row in the visual window model. */
                //void addRowNetward(); 
                void deleteNetwardRow();  /*!< This function is called to delete row from the Yao model. */
                void callNetwardHelp();  /*!< This function is called to help of this directive.*/
		//void initialiserChamps();
		//--void saveNetwardData();      

    private :

            QLineEdit *m_ligneNomNetward;  /*!< Name of the netward. */
            QLineEdit *m_ligneNbiNetward; /*!< QLineEdit for input number. */
            QLineEdit *m_ligneNbsNetward; /*!< Name of the output number. */

            QPushButton *m_enregNetward;  /*!< QPushButton of button Enregistrer */
            QPushButton *m_editNetward;  
            QPushButton *m_quitNetward;  /*!< QPushButton of button Quitter */

            QFormLayout *m_layout1Netward; /*!< QFormLayout for m_layout1Netward decaration */
            QHBoxLayout *m_layoutHNetward;  /*!< QHBoxLayout for m_layoutHNetward decaration */
            QVBoxLayout *m_layoutPrincipalNetward;   /*!< QVBoxLayout for m_layoutPrincipalNetward decaration */
            QTableWidget *vueNetward; /*!< QTableWidget for vueNetward decaration */
            QPushButton *m_AjoutNetward;  /*!< QPushButton of button Ajouter */
            QPushButton *m_SuppNetward;   /*!< QPushButton of button Supprimer */
            bool isCalled; 
            QModelIndex index1;
            QStringList netwardData; 
            QPushButton *m_AideNetward;

};
#endif // NETWARDWINDOW_HPP
