/*!
 * \file    TrajWindow.hpp
 * \brief   Traj class for visual_YAO.
 * \version 2009/12/20 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane & MAYOMBO Alexis.
 */


#ifndef TRAJWINDOW_HPP
#define TRAJWINDOW_HPP
#include "src/Include/Entete.hpp"
#include <QFormLayout>
#include <QString>
#include <QComboBox>
//------------------
#include <QStandardItemModel>
#include <QTableWidget>
#include <QString>
#include <QFileDialog>
#include <QIODevice>
#include <QVBoxLayout>
#include <QTableWidget>
#include<QStringList>
#include <QLabel>
#include "src/Include/NewProjectWindow.hpp"
#include <string>
#include <iostream>
#include <fstream>
#include <QStringListModel>
#include "../YAOObjects/Trajectory.hpp"
#include "../../../help/Enforcer.hpp"
#include "../YAOObjects/Table.hpp"
#include <vector>

using namespace yao;
using namespace std;

class TrajWindow : public QWidget {
           

    Q_OBJECT

    public :
            /*!
             *  \brief Constructor
             *
             *  Constructor of the class TrajWindow
             *
             *  \param Table<Trajectoty> theTrajectoryTable
             */
            TrajWindow(/*const*/ vector<Trajectory> *theTrajectoryTable, QWidget *parent=0);
            void ajouterNomDansTableau(int ligne, int colonne, QString nomTraj);
            void ajouterValeurDansTableau1(int ligne, int colonne, QString valeurTraj);
            //void writefile();
            QStringList getDataTraj();  /*!< This function returns the Trajectory's data. */
            void initialiserChamps(); 
	    void addRow();
    private slots:    /*!< Functions called after a click. */
           
            void ecrireFichierTraj();
            //void enregistrerTraj();
            //void ouvrirProjetExistantTraj();
            void appelAjout();  /*!< This function is called to add row in the visual window model. */
            void appelSupp();   /*!< This function is called to delete row from the Yao model. */
            void callTrajHelp();  /*!< This function is called to an help window. */
            //void ecrireFichier();  /*!< This function is called to add data in the Yao model. */
	    void saveTrajData();  /*!< This function is called to add data in the Yao model. */

    private :

           QLineEdit *m_ligneNomTraj;   /*!< Name of the Trajectory. */
            QLineEdit *m_ligneTypeTraj;  /*!< Type of the Trajectory. */
            QComboBox *m_ligneNbuptimeTraj; /*!< Nbuptime of the Trajectory. */
            QComboBox *m_ligneDtimeTraj;    /*!< Dtime of the Trajectory. */
            QLineEdit *m_ligneNbsteptimeTraj;   /*!< Nbsteptime of the Trajectory. */

            QLineEdit *m_ligneValeurTraj;    /*!< value of the Trajectory. */

            QPushButton *m_enregTraj;    /*!< The button "Enregistrer". */
            QPushButton *m_quitTraj;   /*!< The button "Quitter". */
            QPushButton *m_suppTraj;  /*!< The button "Supprimer". */
            QPushButton *m_AjoutTraj;  /*!< The button "Ajouter". */
            QPushButton *m_AideTraj;  /*!< The button "Aide". */
             

            QFormLayout *m_layout1Traj;   /*!< The form Layout's name. */
            QHBoxLayout *m_layoutHTraj;   /*!< The horizontal Layout's name. */
            QVBoxLayout *m_layoutPrincipalTraj;  /*!< The vertical Layout's name. */
            QFileDialog *projetTraj;
            QString m_cheminProjetTraj;
            ///QVBoxLayout *m_layoutModelTraj;/////////////////////
            QHBoxLayout *m_layoutModelTraj; /*!< The horizontal Layout's name. */
            QComboBox *m_ligneOfftimeTraj;   /*!< m_ligneOffimetraj QComboBox. */
             QStandardItemModel *modeleTraj;
                QTableWidget *vueTraj;   /*!< Name of the QTableWidget's object in whitch the objects are listed for the viewer. */
              //  QFileDialog *fd2;
                QModelIndex index2;
               // QString lstF2;

          QWidget *centralWidget; /*!< name of the principal widget  */
          QWidget *formlayoutWidget1;  /*!< formlayoutWidget1 widget */
          QWidget *formlayoutWidget2;  /*!< formlayoutWidget2 widget */
          QWidget *formlayoutWidget3;  /*!< formlayoutWidget3 widget */
          QFormLayout *formlayout1;   /*!< formlayou1 formlayout */ 
          QFormLayout *formlayout2;   /*!< formlayou2 formlayout */
          QHBoxLayout *formlayout3;  /*!< formlayou3 formlayout */
          QStringList *m_listeTraj;               ////
          QStringListModel *m_modeleListeTraj; ////
          QStringList TrajData;
          
 
         public :
          //vector<vector <Trajectory> > *copytheTrajectoryTable;
          vector<Trajectory> *copytheTrajectoryTable;
          //vector<Trajectory> *copyType;
         //////////////////////////////////////////
          string name;
          int boot;
          int size;
          double step;
          double offset;
          char type;
         
         
};

#endif // TRAJWINDOW_HPP
