//! \file    NetwardWindow.cpp
//! \brief   Implementation of the Netward window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

/*
  Nom du Fichier: .
  Nom de classe:
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

//! \class NetwardWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Netward window for visual_YAO.


#include "Include/NetwardWindow.hpp"

NetwardWindow::NetwardWindow(QWidget *parent) : QWidget(parent) {   /*!< The constructor. */

    this->setWindowTitle("Directive Netward.");    /*!< To set the window's title. */

    m_ligneNomNetward        = new QLineEdit;   /*!< Name of the QLineEdit. */
    m_ligneNbiNetward        = new QLineEdit;  /*!< input number of the QLineEdit. */
    m_ligneNbsNetward        = new QLineEdit;  /*!< output of the QLineEdit. */

    m_layout1Netward         = new QFormLayout;   /*!< QFormLayout for the m_layout1Netward. */
    //Les gestionnaires de positionnement
    m_layout1Netward->addRow("Netname: ", m_ligneNomNetward);  /*!< added m_ligneNomNetward */
    m_layout1Netward->addRow("Nombre Entree: ", m_ligneNbiNetward);  /*!< added m_ligneNbiNetward */
    m_layout1Netward->addRow("Nombre Sortie: ", m_ligneNbsNetward);  /*!< added m_ligneNbsNetward */
     QGroupBox *groupDefinition = new QGroupBox("");  /*!< QGroupBox for groupDefinition */
    	groupDefinition->setLayout(m_layout1Netward);   /*!< displays m_layout1Netward */

    vueNetward 		= new QTableWidget(0, 3);  /*!< vueNetward declaration */ 
    vueNetward->setEditTriggers(QAbstractItemView::NoEditTriggers); /*!< this ligne give no edit mode*/
    vueNetward->setShowGrid(false); /*!< this ligne cover the grille in table */
    vueNetward->setSelectionBehavior(QAbstractItemView::SelectRows);  /*!< this ligne give a section of the ligne */


    QStringList horizontalHeaders;
    horizontalHeaders << "Nom Netward" << "Entrees" << "Sorties"; /*!< added Nom Netward Entrees and sorties in table */
    vueNetward->setHorizontalHeaderLabels(horizontalHeaders);  /*!< displays the QTableWidget */
    index1 = vueNetward->currentIndex(); 

    m_AjoutNetward           = new QPushButton("Ajouter"); /*!< The button "add". */
    m_SuppNetward            = new QPushButton("supprimer");  /*!< The button "delete". */
    m_AideNetward            = new QPushButton("De l'Aide?");  /*!< QPushButton for the button aide */
    QGridLayout *layout1 = new QGridLayout;
    layout1->addWidget(m_AideNetward, 1,0);  /*!< added tableWidgetfct */
    layout1 -> addWidget(vueNetward, 0,1,5,1);
    layout1 -> addWidget(m_AjoutNetward, 1,2); 
    layout1 -> addWidget(m_SuppNetward, 2,2); 
    QGroupBox *groupOptions = new QGroupBox("");
    groupOptions->setLayout(layout1);

    m_enregNetward           = new QPushButton("Enregistrer"); /*!< The button "save". */
    m_quitNetward            = new QPushButton("Quitter");  /*!< The button "Quit". */
    QHBoxLayout *boutonsLayout = new QHBoxLayout;
    //boutonsLayout->setAlignment(Qt::AlignRight);

    boutonsLayout->addWidget(m_enregNetward);
    boutonsLayout->addWidget(m_quitNetward);

    QVBoxLayout *layoutPrincipal = new QVBoxLayout;
    layoutPrincipal->addWidget(groupDefinition);
    layoutPrincipal->addWidget(groupOptions);
    //layoutPrincipal->addWidget(groupCommentaires);
    layoutPrincipal->addLayout(boutonsLayout);

    setLayout(layoutPrincipal);

        connect(m_quitNetward, SIGNAL(clicked()), this, SLOT(close()));
        connect(m_SuppNetward, SIGNAL(clicked()), this, SLOT(deleteNetwardRow()));
        connect(m_AjoutNetward, SIGNAL(clicked()), this, SLOT(addNetwardRow()));
        connect(m_AideNetward, SIGNAL(clicked()), this, SLOT(callNetwardHelp()));
	//connect(m_enregNetward, SIGNAL(clicked()), this, SLOT(saveNetwardData()));
  
}
/****************************************************************************************/
void NetwardWindow::addNetwardRow() {
 
	//addRow();
       // addRowNetward();
                 static int row = 0;
                 int l = 0;
	QString nomfct = m_ligneNomNetward -> text();
	QString entrefct = m_ligneNbiNetward -> text();
        QString sortifct = m_ligneNbsNetward -> text();
       
         for(int i1 = 0; i1 < nomfct.size(); i1++)
        //if (m_ligneNomTraj->text().isEmpty())
     if(!((nomfct.at(i1) >= QChar('a')&& nomfct.at(i1) <= QChar('z')) || (nomfct.at(i1) >= QChar('A')&& nomfct.at(i1) <= QChar('Z')) //--------
         || (nomfct.at(i1) >= QChar('0')&& nomfct.at(i1) <= QChar('9')) || (nomfct.at(i1) == QChar('_')))) //|| (line1.isEmpty())
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur exacte du nom netward.");
        return; // Arrêt de la méthode
    }
       for(int i2 = 0; i2 < entrefct.size(); i2++)
        //if (m_ligneNomTraj->text().isEmpty())
     if(!((entrefct.at(i2) >= QChar('0') && entrefct.at(i2) <= QChar('9')) || (entrefct.at(i2) == QChar('-')) || (entrefct.at(i2) == QChar('E')) || (entrefct.at(i2) == QChar('e')) || (entrefct.at(i2) == QChar('+')) || (entrefct.at(i2) == QChar('.')))) //|| (line1.isEmpty())
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte de l'etree.");
        return; // Arrêt de la méthode
    }
        for(int il = 0; il < sortifct.size(); il++)
        //if (m_ligneNomTraj->text().isEmpty())
     if(!((sortifct.at(il) >= QChar('0') && sortifct.at(il) <= QChar('9')) || (sortifct.at(il) == QChar('-')) || (sortifct.at(il) == QChar('E')) || (sortifct.at(il) == QChar('e')) || (sortifct.at(il) == QChar('+')) || (sortifct.at(il) == QChar('.')))) //|| (line1.isEmpty())
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte de la sortie.");
        return; // Arrêt de la méthode
    }


       if ( m_ligneNomNetward->text().isEmpty())
        {
    QMessageBox::critical(this, "Erreur", "Le champ du nom netward est vide: entrer un nom SVP!");
        return; // Arrêt de la méthode
    }
          
             if (l >= 0)
{
            
      vueNetward->setItem(row, 0, new QTableWidgetItem(m_ligneNomNetward -> text()));
      vueNetward->setItem(row, 1, new QTableWidgetItem(m_ligneNbiNetward -> text()));
      vueNetward->setItem(row, 2, new QTableWidgetItem(m_ligneNbsNetward -> text()));  
               
      netwardData.push_back(m_ligneNomNetward -> text() + " " + m_ligneNbiNetward -> text() + " " + m_ligneNbsNetward -> text());
          
       
    row++;
} 

    //m_supDefval->setEnabled(true);
    //initialiserChamps();


}
/****************************************************************************************/
void NetwardWindow::deleteNetwardRow() {

	vueNetward->removeRow(vueNetward->currentRow());
    	isCalled = true;


}

/****************************************************************************************/
/*void NetwardWindow::ajouterNameDansTableau(int ligne, int colonne, QString nomfct1) {
    QTableWidgetItem *chaine1 = new QTableWidgetItem;
    chaine1->setText(nomfct1);

      nomfct1->setItem(ligne-1, colonne-1, new QTableWidgetItem(nomfct1));
}*/

/****************************************************************************************/
/*void NetwardWindow::ajouterInputDansTableau(int ligne, int colonne, QString entrefct1) {

QTableWidgetItem *chaine1 = new QTableWidgetItem;
chaine1->setText(entrefct1);

    entrefct1->setItem(ligne - 1, colonne, chaine1);

}*/
/****************************************************************************************/
/*void NetwardWindow::ajouterOutputDansTableau(int ligne, int colonne, QString sortifct) {
    QTableWidgetItem *chaine1 = new QTableWidgetItem;
    chaine1->setText(sortifct);

      sortifct->setItem(ligne-1, colonne-1, new QTableWidgetItem(sortifct));
}*/
/****************************************************************************************/
/*void NetwardWindow::addRowNetward() {

	int row = vueNetward->rowCount();
	vueNetward->insertRow(row);

}*/
/****************************************************************************************/
/*void NetwardWindow::saveNetwardData() {

	QTableWidgetItem *cel1 = new QTableWidgetItem;
	QTableWidgetItem *cel2 = new QTableWidgetItem;	
	
	for (int i = 0; i < vueNetward->rowCount() ; i++) {
			cel1 = vueNetward->item(i,0);
			cel2 = vueNetward->item(i,1);
				
			//defvalData.push_back(cell1->text() + " " + cell2->text());
         		
		}
	//for (QStringList::iterator it = defvalData.begin(); it != defvalData.end(); it++)
	//cout << "Voici les valeurs ajoutées: " << it->toStdString() <<endl;

}*/
/****************************************************************************************/
/*void DefvalWindow::initialiserChamps() {

     	   m_ligneNomDefval->setText("");
	   m_ligneValeurDefval->setText("");
}*/

/************************************ Implémentation de la méthode callHelpDefval ****************************************/
/*void NetwardWindow::callNetwardHelp()
{
    QMessageBox::about(this, tr("Aide sur la directive Netward."),("<p> La directive Netward permet  d'associer un nom symbolique a une valeur."
                                                                  "<p><u>Exemple 1</u>: deval szx 12 <p><u>Exemple 2</u>: defval szy \"chaine\"<p> <u>Exemple 3</u>: defval szz szx"));
}*/

/****************************************************************************************/
QStringList NetwardWindow::getDataNetward() {

    
     return netwardData;
}
/**************************************************************************************/
void NetwardWindow::callNetwardHelp() {

  QMessageBox::about(this, tr("Aide sur la directive Netward."),("<p> Elle sert a définir une , "
                              " "
                              " "
                              ""
                              "<br> <a href=\"help/netward_aide.html\">lien HTML Cliquez ici SVP !</a>"));

}


