
/*
  Nom du Fichier: NewProjectWindow.cpp
  Nom de classe: NewProjectWindow
  Role: Cree un repertoire qui portera le nom du projet et y met tous les fichiers relatifs à ce projet.
  Nombre de methodes: 10
  Nombre de slots   : 2
  Nombre d'attributs: 10
  */

#include "Include/NewProjectWindow.hpp"

using namespace std;

/********************************************************************************************************************************************/
NewProjectWindow::NewProjectWindow(QWidget *parent) : QWidget(parent){

    //copyTheHeaderList = theHeaderList;
        //name = projectName;
    //theHeaderList = &theHeaders;

    this->setWindowTitle("Fenêtre de création d'un nouveau projet.");

	m_spacer				= new QSpacerItem(165, 1);
	//QSpacerItem *m_spacer2	= new QSpacerItem(1, 200);
    ligneNomRep             = new QLineEdit; 			// Le champ de saisie du nom du repertoire.
    ligneInfos              = new QTextEdit; 			// Le champ de saisie des infos relatives à un projet.
    m_layoutF               = new QFormLayout;			// Le gestionnaire de positionnement principal de la fenetre.
    m_layoutH               = new QHBoxLayout;			// Un des gestionnaires de positionnement horizontal.
    m_creerRepertoireProjet = new QPushButton("Créer", this); // Le bouton valider.
    m_quitProjet            = new QPushButton("Annuler", this);	// Le bouton quitter.

	//m_layoutH->insertSpacerItem(0, m_spacer);
	m_layoutH->addWidget(m_creerRepertoireProjet);		// Ajout du bouton "valider" dans le gestionnaire principal.
	m_layoutH->addWidget(m_quitProjet);				// Ajout du bouton "quitter" dans le gestionnaire principal.
	//m_layoutH->insertSpacerItem(0, m_spacer);
	//m_layoutH->insertSpacerItem(-1, m_spacer);  	
	//m_layoutH->addSpacerItem(m_spacer);   
	  
   
    m_layoutF->addRow("Nom du nouveau projet: ", ligneNomRep);	// Ajout du champ de saisie du nom de repertoire dans le gestionnaire principal. 
	//m_layoutF->setFormAlignment(Qt::AlignHCenter);    
    m_layoutF->addRow("Quelques informations: ", ligneInfos);	// Ajout du champ de saisie des infos dans le gestionnaire principal.
    m_layoutF->addRow(m_layoutH);				// Ajout du gestionnaire horizontal le gestionnaire principal.

    this->setLayout(m_layoutF);
        connect(m_quitProjet, SIGNAL(clicked()), this, SLOT(close()));
        connect(m_creerRepertoireProjet, SIGNAL(clicked()), this, SLOT(createProjectDirectory()));
        connect(m_creerRepertoireProjet, SIGNAL(clicked()), this, SLOT(close()));
        //connect(m_creerRepertoireProjet, SIGNAL(clicked()), this, SLOT(CreatHatFile()));
        
        //setNewProjectName(ligneNomRep->text().toStdString());
       //setNewProjectName(newProjectName);

	this->move(width()/3,height()/3);
	this->show();
}


/*********************************** Implementation de la methode CreatFileHat ******************************************/

void NewProjectWindow::createHatFile() {


	  // The hat file genereted automatically.
	  //string filename = "projects/" + getNomProjet().toStdString() + "/" + getNomProjet().toStdString() + ".h";
          string filename = getNewProjectName() + ".h";
          string filepath = "projects/" + getNewProjectName() + "/" + getNewProjectName() + ".h";

          ofstream hat(filepath.c_str(), ios::out | ios::binary | ios::trunc);
          if(!hat.is_open())
                        throw ofstream::failure("couldn't create " + filename);

hat << "/*****************************************************************************************************" << endl;
hat << "* Fichier chapeau généré automatiquement par Visual YAO." << endl;
hat << "* Le fichier chapeau permet à l'utilisateur d'intervenir pendant l'exécution de l'application YAO." << endl;
hat << "* On peut déclarer des variables globales et des fonctions spécifiques de l'application définies    *" << endl;
hat << "* par l'utilisateur dans le fichier description (dans ce cas là on ajoute aussi les prototypes.     *" << endl;
hat << "* Dans ce fichier il faut toujours avoir les fonctions spécifiques mais obligatoires pour YAO       *" << endl
    << "* (celles de ce squelette).                                                                         *" << endl
    << "*****************************************************************************************************/" << endl;


hat << "// DECLARATION DE VARIABLES GLOBALES (si nécessaire) :" << endl
	  << endl
	    << endl
	      << endl
 << "// PROTOTYPAGE (si nécessaire) :" << endl
		  << endl
		    << endl
		      << endl
 << "// FONCTIONS SPECIFIQUES (mais obligatoires pour YAO) :" << endl
 << "// Permet si besoin de prendre la main des le début de l'application." << endl
 << "void appli_start(int argc, char *argv[]){ }" << endl
 << endl
 << "// Intervenir avant une itération." << endl
 << "void before_it(int nit){ }" << endl
 << endl
 << "// Fonction de coût spécifique." << endl
 << "void cost_function(int pdt){ }" << endl
 << endl
 << "// Fonction d'ajustement spécifique." << endl
 << "void adjust_target(){ }" << endl
      << endl
 << "// Intervenir après une itération." << endl
 << "void after_it(int nit){ }" << endl
 << endl
 << "// Intervenir avant le forward." << endl
 << endl
 << "// Intervenir avant le forward." << endl
 << "void forward_before(int ctrp){ }" << endl
 << endl
 << "// Intervenir après le forward." << endl
 << "void forward_after(int ctrp){ }" << endl
<< endl
 << "// Intervenir avant le backward." << endl
 << "void backward_before(int ctrp){ }" << endl
      << endl
 << "// Intervenir après le backward." << endl
 << "void backward_after(int ctrp){ }" << endl
	    << endl
<< "// Permet d'agir lorsqu'on appelle les fonctions d'I/O de YAO." << endl
  << "short select_io(int indic, char *nmod, int sortie, int iaxe, int jaxe, int kaxe, int pdt, YREAL *val){ }" << endl
    << endl
      << endl
        << endl
 << "// FONCTIONS SPECIFIQUES de l'application (si nécessaire) :" << endl
  << endl;

    hat.close();
    //for (vector <string>::iterator it = newProjectList.begin(); it != newProjectList.end(); it++)
    //setNewProjectList(filename);

}


/************************************* Implementation de la méthode createProjectDirectory ************************************/

void NewProjectWindow::createProjectDirectory() {

    setNewProjectName(ligneNomRep->text().toStdString());

    setProjectPath(QDir::currentPath() + "/projects");

    QDir rep(QString(getProjectPath().c_str()));
        if (!rep.exists(QString(getNewProjectName().c_str())))  // c_str is used for having the Qt string form (this form is QString)
          { rep.mkdir(QString(getNewProjectName().c_str()));
                createFile("", ".d");
                createHatFile();
                createFile(ligneInfos->toPlainText().toStdString(), ".txt");

            QMessageBox::about(this, tr("Operation reussie"),
                               tr("<p>Nouveau projet cree avec succes.<p> Cliquer sur <b>ok</b> pour fermer cette fenetre."));
        }
      else
          QMessageBox::about(this, tr("Nouveau projet"), tr("<p>Le projet existe deja! <p> Veuillez changer le nom."));

 //cout << "Nombre d'elements: " << (int) newProjectList.size() << endl;

  }
/************************************ Implementation de la méthode setNomProjet ***********************************************/

void NewProjectWindow::setNewProjectName(std::string chaine) {

    newProjectName = chaine; //Fonction permettant d'initialiser ou de donner un nom au projet.
}

/************************************* Implementation de la methode getNomProjet *********************************************/

string NewProjectWindow::getNewProjectName() {
    return newProjectName; // Lorsqu'elle est appelée, elle retourne le nom d'un projet.
}

/************************************* Implementation de la methode setCheminProjet *************************************************************/

void NewProjectWindow::setProjectPath(QString chaine) {

    m_cheminProjet = chaine.toStdString() ; //Fonction permettant d'initialiser ou de donner un chemin d'un projet.
}

/************************************* Implementation de la methode getCheminProjet ***********************************************************/
string NewProjectWindow::getProjectPath() {

    return m_cheminProjet;
}

/******************************************************************************************************************************/
void NewProjectWindow::createFile(string data, string extension) {

    string filename = getNewProjectName() + extension;
    string filepath = "projects/" + getNewProjectName() + "/" + getNewProjectName() + extension;

          ofstream h_file(filepath.c_str(), ios::out | ios::binary | ios::trunc);
          if(!h_file.is_open())
                        throw ofstream::failure("couldn't create " + filename);
                h_file << data << endl;

    h_file.close();

  }

/*************************************** Implementation de la methode  *****************************************************************/
void NewProjectWindow::setNewProjectList(string aNewProjectList) {

        newProjectList.push_back(aNewProjectList);
}

/******************************************************************************************************************************/
std::vector<string> NewProjectWindow::getNewProjectList() {

    return newProjectList;
}


/******************************************************************************************************************************/
/*void NewProjectWindow::() {


}*/
/******************************************************************************************************************************/
