//! \file    OperaWindow.cpp
//! \brief   Implementation of the Opera window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

/*
  Nom du Fichier: OperaWindow.cpp
  Nom de classe: OperaWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */
//! \class OperaWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Opera window for visual_YAO.

#include "Include/OperaWindow.hpp"
OperaWindow::OperaWindow(QWidget *parent) : QWidget(parent) {

    this->setWindowTitle("Directive Opera.");

    	m_labelOperaName		= new QLabel("Nom: ");
    	m_labelOperaType		= new QLabel("Type: ");
		m_labelOperaD1			= new QLabel("D1: ");
		m_labelOperaD2			= new QLabel("D2: ");
		m_labelOperaD3			= new QLabel("D3: ");
		m_labelOperaTraj		= new QLabel("Trajectoire: ");
	    	
    	m_ligneNomOpera        = new QLineEdit(this);
    	m_ligneTypeOpera       = new QLineEdit(this);

    	m_ligneD1Opera         = new QLineEdit(this);
    	m_ligneD2Opera         = new QLineEdit(this);
    	m_ligneD3Opera         = new QLineEdit;
    	m_ligneTrajnameOpera   	= new QLineEdit;

	m_helpOperaButton	= new QPushButton("De l'aide? ", this);
	m_addOperaButton	= new QPushButton("Ajouter", this);
	m_deleteOperaButton	= new QPushButton("Supprimer", this); 
    m_enregOpera           	= new QPushButton("Enregistrer");
    m_quitOpera            	= new QPushButton("Quitter");
    
	m_operaTableView	= new QTableWidget;

    //Les gestionnaires de positionnement
	m_operaLayoutV1		= new QVBoxLayout;
		m_operaLayoutV1->addWidget(m_addOperaButton);
		m_operaLayoutV1->addWidget(m_deleteOperaButton);

	m_operaLayoutH1		= new QHBoxLayout;	
		m_operaLayoutH1->addWidget(m_operaTableView);
    		m_operaLayoutH1->addLayout(m_operaLayoutV1);
    		//m_operaLayoutH1->addWidget();

	m_operaLayoutH2		= new QHBoxLayout;	
		m_operaLayoutH2->addWidget(m_enregOpera);
    	m_operaLayoutH2->addWidget(m_quitOpera);
    	
    m_operaLayoutG		= new QGridLayout;
    		m_operaLayoutG->addWidget(m_labelOperaName, 0, 1);
    		m_operaLayoutG->addWidget(m_ligneNomOpera, 0, 2, Qt::AlignLeft);
    		m_operaLayoutG->addWidget(m_labelOperaType, 1, 1);
    		m_operaLayoutG->addWidget(m_ligneTypeOpera, 1, 2, Qt::AlignLeft);
    		m_operaLayoutG->addWidget(m_labelOperaD1, 2, 1);
    		m_operaLayoutG->addWidget(m_ligneD1Opera, 2, 2, Qt::AlignLeft);
    		m_operaLayoutG->addWidget(m_labelOperaD2, 3, 1);
    		m_operaLayoutG->addWidget(m_ligneD2Opera, 3, 2, Qt::AlignLeft);
    		m_operaLayoutG->addWidget(m_labelOperaD3, 4, 1);
    		m_operaLayoutG->addWidget(m_ligneD3Opera, 4, 2, Qt::AlignLeft);
    		m_operaLayoutG->addWidget(m_labelOperaTraj, 5, 1);
    		m_operaLayoutG->addWidget(m_ligneTrajnameOpera, 5, 2, Qt::AlignLeft);
    		m_operaLayoutG->addWidget(m_helpOperaButton, 7, 0);
    		m_operaLayoutG->addWidget(m_operaTableView, 6, 1, 4, 4);
    		m_operaLayoutG->addWidget(m_addOperaButton, 7, 5);
    		m_operaLayoutG->addWidget(m_deleteOperaButton, 8, 5);
    		m_operaLayoutG->addLayout(m_operaLayoutH2, 10, 1, 1, 4);		
    		
    		
  	/*m_layoutOpera		= new QFormLayout; 
    		m_layoutOpera->addRow("Operaname: ", m_ligneNomOpera);
    		m_layoutOpera->addRow("Type: ", m_ligneTypeOpera);
    		m_layoutOpera->addRow("D1: ", m_ligneD1Opera);
    		m_layoutOpera->addRow("D2: ", m_ligneD1Opera);
    		m_layoutOpera->addRow("D3: ", m_ligneD3Opera);
    		m_layoutOpera->addRow("Trajname: ", m_ligneTrajnameOpera);
			m_layoutOpera->addRow(m_operaLayoutH1);
                m_layoutOpera->addRow(m_operaLayoutH2);*/


    	this->setLayout(m_operaLayoutG);

        connect(m_quitOpera, SIGNAL(clicked()), this, SLOT(close()));
    //this->show();
}


