//! \file    OptionWindow.cpp
//! \brief   Implementation of the Option window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

/*
  Nom du Fichier: OptionWindow.cpp
  Nom de classe:
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "Include/OptionWindow.hpp"

//! \class OptionWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Option window for visual_YAO.

OptionWindow::OptionWindow(QWidget *parent) : QWidget(parent) {

   this->setWindowTitle("Directive Option.");

    	m_optionLayout          = new QFormLayout;
    	m_optionLayoutH1        = new QHBoxLayout;
	m_optionLayoutH2        = new QHBoxLayout;
    	m_optionLayoutV1	= new QVBoxLayout;
	m_layoutGOption		= new QGridLayout;	
	
	m_labelName		= new QLabel("Nom de l'option: ");
	m_comboNomOption        = new QComboBox;


	m_optionAddButton	= new QPushButton("Ajouter", this);
	m_optionDeleteButton	= new QPushButton("Supprimer", this);        
	m_enregOption           = new QPushButton("Enregistrer" , this);
	m_optionHelpButton	= new QPushButton("De l'aide ?" , this);
    	m_quitOption            = new QPushButton("Quitter", this);

		m_comboNomOption->insertItem(1, "O_M1QN3");        
		m_comboNomOption->insertItem(2, "O_NETWARD");
        	m_comboNomOption->insertItem(3, "O_REAL");
        	m_comboNomOption->insertItem(4, "O_VARINCR");
        	m_comboNomOption->insertItem(5, "O_EXTOBJ");
        	m_comboNomOption->insertItem(6, "O_GRADTEST");
        	m_comboNomOption->insertItem(7, "O_DBG_TING");
        	m_comboNomOption->insertItem(8, "O_DBG_BETA");
        	m_comboNomOption->insertItem(9, "O_DBG_NANF");
        	m_comboNomOption->insertItem(10, "O_DBG_TRC_FWARD");
        	m_comboNomOption->insertItem(11, "O_DBG_TRC_BWARD");
        	m_comboNomOption->insertItem(12, "O_DBG_TRC_LWARD");
        	m_comboNomOption->insertItem(13, "O_DBG_TRC_AWARD");
		
	//filesList << "file 1";	
	

	filesListModele = new QStringListModel(filesList);

        m_optionListView = new QListView ;   
	
	m_optionListView->setModel(filesListModele);

	m_optionLayoutH2	= new QHBoxLayout; 
		m_optionLayoutH2->addWidget(m_enregOption);
		m_optionLayoutH2->addWidget(m_quitOption);
	

	m_layoutGOption->addWidget(m_labelName, 0, 0);
    	m_layoutGOption->addWidget(m_comboNomOption, 0, 1);
	m_layoutGOption->addWidget(m_optionHelpButton, 2, 0);
	m_layoutGOption->addWidget(m_optionListView, 1, 1, 4, 2);
	m_layoutGOption->addWidget(m_optionAddButton, 2, 3);
	m_layoutGOption->addWidget(m_optionDeleteButton, 3, 3);

	m_layoutGOption->addLayout(m_optionLayoutH2, 5, 1, 1, 2);

	
	/* 	
	m_optionLayoutH1	= new QHBoxLayout ;     
		m_optionLayoutH1->addWidget(m_optionListView);
		m_optionLayoutH1->addLayout(m_optionLayoutV1);

	

	
	//Les gestionnaires de positionnement
	m_optionLayout		= new QFormLayout; 	
		m_optionLayout->addRow("Option name: ", m_m_comboNomOption);
		m_optionLayout->addRow(m_optionLayoutH1);
		m_optionLayout->addRow(m_optionLayoutH2);
	// m_layout1Option->addRow("Chemin ", m_boutonCheminProjet);
	

   */

	
	

	this->setLayout(m_layoutGOption);
    

	connect(m_enregOption, SIGNAL(clicked()), this, SLOT(saveOptionData()));
        connect(m_quitOption, SIGNAL(clicked()), this, SLOT(close()));
        connect(m_optionAddButton, SIGNAL(clicked()), this, SLOT(addOptionRow()));
	connect(m_optionDeleteButton, SIGNAL(clicked()), this, SLOT(deleteOptionRow()));
	//connect(m_optionHelpButton , SIGNAL(clicked()), this, SLOT(()));
	
	//this->show();

}
/**************************************** Implémentation de la méthode addOptionRow *****************************************************************/
void OptionWindow::addOptionRow() {

	filesList.append(m_comboNomOption->currentText());
	filesListModele->setStringList(filesList);
	
}

/*************************************** Implémentation de la méthode deleteOptionRow ****************************************************************/
void OptionWindow::deleteOptionRow() {

	QItemSelectionModel *selection = m_optionListView->selectionModel();
	QModelIndex indexElementSelectionne = selection->currentIndex();
    	QVariant elementSelectionne = filesListModele->data(indexElementSelectionne, Qt::DisplayRole);

     	filesList.removeOne(elementSelectionne.toString());//Retrait de l'élément sélectionné de l'objet QStringList
     	filesListModele->setStringList(filesList); //On indique au modèle la liste des éléments à afficher.

	
}


/*****************************************************************************************************************************/
void OptionWindow::saveOptionData() {
	
	//anVector = filesList;
	//for(QStringList::iterator it = filesList.begin(); it != filesList.end(); it++)
		//anVector.push_back(it);	
		//anVector = filesList.c_str();
		
	//m_theContext->addExternal(anVector);
    
}
/*****************************************************************************************************************************/
void OptionWindow::enregistrerOption() {
  projetOption = new QFileDialog(this);
  QStringList filtres;

  projetOption->setDirectory(".");
  projetOption->setFileMode (QFileDialog::AnyFile);
  filtres << "*.h"
          << "Tous les fichiers (*.*)";
  projetOption->setFilters(filtres);

  //if(fd->exec()) {
    m_cheminProjetOption = projetOption->getSaveFileName();

}
/*****************************************************************************************************************************/
void OptionWindow::ouvrirProjetExistant3() {

    projetOption = new QFileDialog(this);
  QStringList filtres;

  projetOption->setDirectory(".");
  projetOption->setFileMode (QFileDialog::AnyFile);
  filtres << "*.h"
          << "Tous les fichiers (*.*)";
  projetOption->setFilters(filtres);

    m_cheminProjetOption = projetOption->getSaveFileName();
 }

/****************************************************************************************************************************/
QStringList OptionWindow::getOptionData() {

	return filesList;
}
