//! \file    OrderWindow.cpp
//! \brief   Implementation of the OrderWindow window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

/*
  Nom du Fichier: OrderWindow.cpp
  Nom de classe: OrderWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "Include/OrderWindow.hpp"

//! \class OrderWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Order window for visual_YAO.

OrderWindow::OrderWindow(QWidget *parent) : QWidget(parent) {

            this->setWindowTitle("Directive Order.");
            m_layout1Order          = new QFormLayout;
            m_layoutHOrder          = new QHBoxLayout;
            m_layoutPrincipalOrder  = new QVBoxLayout;

            m_ligneModeInSpaceOrder = new QLineEdit;

            m_ligneSpaceNameOrder   = new QLineEdit;
            m_ligneBaseOrder        = new QLineEdit;

            m_enregOrder            = new QPushButton("Enregistrer");
            m_editOrder             = new QPushButton("Editer");
            m_quitOrder             = new QPushButton("Fermer");

                connect(m_quitOrder, SIGNAL(clicked()), this, SLOT(close()));

            m_layout1Order->addRow("Modin: ", m_ligneModeInSpaceOrder);
            m_layout1Order->addRow("NameOrder: ", m_ligneSpaceNameOrder);
            m_layout1Order->addRow("BaseOrder: ", m_ligneBaseOrder);

            m_layoutHOrder->addWidget(m_enregOrder);
            m_layoutHOrder->addWidget(m_editOrder);
            m_layoutHOrder->addWidget(m_quitOrder);

            m_layoutPrincipalOrder->addLayout(m_layout1Order);
            m_layoutPrincipalOrder->addLayout(m_layoutHOrder);

            this->setLayout(m_layoutPrincipalOrder);

}
