//! \file    ParametersViewer.cpp
//! \brief   Implementation of the ParametersViewer window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.


#include "Include/ParametersViewer.hpp"

//! \class ParametersViewer(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the ParametersViewer window for visual_YAO.

ParametersViewer::ParametersViewer(QWidget *parent) : QWidget(parent) {

    tableWidget = new QTableWidget(0, 2);
    tableWidget->setHorizontalHeaderLabels(
            QStringList() << tr("Parametre") << tr("Valeur"));

    for (int row = 0; row < 4; ++row) {
        static QString chaine = "nom" ;
        ajouterLigne();
         tableWidget->item(row, 0)->setText(chaine);
        chaine = "valeur";
        tableWidget->item(row, 1)->setText(chaine);
        chaine = "chaine_suivante";
   }


    addRowButton = new QPushButton(tr("Ajouter"));
    okButton = new QPushButton(tr("Valider"));
    okButton->setDefault(true);
    cancelButton = new QPushButton(tr("Annuler"));
    connect(addRowButton, SIGNAL(clicked()), this, SLOT(ajouterLigne()));
    connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(close()));

    buttonLayout = new QHBoxLayout;
    buttonLayout->addWidget(addRowButton);
    buttonLayout->addStretch();
    buttonLayout->addWidget(okButton);
    buttonLayout->addWidget(cancelButton);

    mainLayout = new QVBoxLayout;
    mainLayout->addWidget(tableWidget);
    mainLayout->addLayout(buttonLayout);
    setLayout(mainLayout);

    setWindowTitle(tr("Affichage des parametres"));
}

/******************************************************************************************************************************/
ParametersViewer::ParametersViewer(QString nom, QString valeur, QWidget *parent) : QWidget(parent) {

    tableWidget = new QTableWidget(0, 2);
    tableWidget->setHorizontalHeaderLabels(
            QStringList() << tr("Parametre") << tr("Valeur"));

    for (int row = 0; row < 4; ++row) {
        //static QString chaine = "nom" ;
        ajouterLigne();

        //for (int row2 = 0; row2 < 2; ++row2) {

         tableWidget->item(row, 0)->setText(nom);
        //chaine = "valeur";
        tableWidget->item(row, 1)->setText(valeur);

        //}
        //chaine = "chaine_suivante";
   }


    addRowButton = new QPushButton(tr("Ajouter"));

    okButton = new QPushButton(tr("Valider"));
    okButton->setDefault(true);

    cancelButton = new QPushButton(tr("Annuler"));

    connect(addRowButton, SIGNAL(clicked()), this, SLOT(ajouterLigne()));
    connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(quit()));

    buttonLayout = new QHBoxLayout;
    buttonLayout->addWidget(addRowButton);
    buttonLayout->addStretch();
    buttonLayout->addWidget(okButton);
    buttonLayout->addWidget(cancelButton);

    mainLayout = new QVBoxLayout;
    mainLayout->addWidget(tableWidget);
    mainLayout->addLayout(buttonLayout);
    setLayout(mainLayout);

    setWindowTitle(tr("Affichage des parametres"));
}
/******************************************************************************************************************************/

void ParametersViewer::ajouterLigne()
{
    int row = tableWidget->rowCount();

    tableWidget->insertRow(row);

    QTableWidgetItem *item0 = new QTableWidgetItem;
    item0->setTextAlignment(Qt::AlignRight | Qt::AlignVCenter);
    tableWidget->setItem(row, 0, item0);

    QTableWidgetItem *item1 = new QTableWidgetItem;
    item1->setTextAlignment(Qt::AlignRight | Qt::AlignVCenter);
    tableWidget->setItem(row, 1, item1);

    tableWidget->setCurrentItem(item0);

}

