/*!
 * \file    TrajWindow.cpp
 * \brief   Traj class for visual_YAO.
 * \version 2009/12/03 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane & MAYOMBO Alexis.
 */

#include "Include/TrajWindow.hpp"
#include <sstream>

using namespace std;
using namespace yao;
//////////////////////////////////////////////

TrajWindow::TrajWindow(/*const*/ vector<Trajectory> *theTrajectoryTable, QWidget *parent) : QWidget(parent) {  /*!< The constructor. */
    
     copytheTrajectoryTable = theTrajectoryTable;
   

    this->setWindowTitle("Directive Trajectoire.");   /*!< To set the window's title. */
    this->resize(710,495);    /*!< To set the window's size. */

    centralWidget = new QWidget(this);  /*!< principal widget */
    formlayoutWidget1 = new QWidget(centralWidget);  /*!<formlayoutWidget1  QWidget */
    formlayoutWidget1 -> setGeometry(QRect(30, 10, 360, 181));  /*!< size of the Widget */
    formlayout1 = new QFormLayout(formlayoutWidget1);  /*!< formlayout1 QFormLayout */

    m_ligneNomTraj        = new QLineEdit(formlayoutWidget1);  /*!< Name of the QLineEdit. */

    m_ligneTypeTraj       = new QLineEdit("M", formlayoutWidget1);  /*!< Type of the QLineEdit. */

     m_ligneNbuptimeTraj  = new QComboBox(formlayoutWidget1);    /*!< Nbuptime of the QComboBox. */
     m_ligneNbuptimeTraj->setEditable(true);
     m_ligneNbuptimeTraj ->addItem("");
     m_ligneNbuptimeTraj ->addItem("");
     m_ligneNbuptimeTraj ->addItem("");
     m_ligneNbuptimeTraj ->addItem("");

     m_ligneOfftimeTraj   = new QComboBox(formlayoutWidget1);     /*!< Offtime of the QComboBox. */
     m_ligneOfftimeTraj ->setEditable(true);
     m_ligneOfftimeTraj  ->addItem("0");
     m_ligneOfftimeTraj  ->addItem("");
     m_ligneOfftimeTraj  ->addItem("");
     m_ligneOfftimeTraj  ->addItem("");

     m_ligneDtimeTraj    = new QComboBox(formlayoutWidget1);   /*!< Dtime of the QComboBox. */
     m_ligneDtimeTraj  ->setEditable(true);
     m_ligneDtimeTraj   ->addItem("1");
     m_ligneDtimeTraj   ->addItem("");
     m_ligneDtimeTraj   ->addItem("");
     m_ligneDtimeTraj   ->addItem("");


     m_ligneNbsteptimeTraj = new QLineEdit(formlayoutWidget1);  /*!< Nbsteptime of the QComboBox. */


         //Give position for the widget
    formlayout1->addRow("Nom: ", m_ligneNomTraj);   /*!< added m_ligneNomTraj */
    formlayout1->addRow("Type: ", m_ligneTypeTraj);  /*!< added m_ligneTypeTraj */
    formlayout1->addRow("Pas de temps (uptime):", m_ligneNbuptimeTraj);  /*!< added m_ligneNbuptimeTraj */
    formlayout1->addRow("Décalage (Offtime):", m_ligneOfftimeTraj);   /*!< added m_ligneOfftimeTraj */
    formlayout1->addRow("Position (DTime): ", m_ligneDtimeTraj);   /*!< added m_ligneDtimeTraj */
    formlayout1->addRow("Pas de temps de la traj. (Nbsteptime): ", m_ligneNbsteptimeTraj);  /*!< added m_ligneNbsteptimeTraj */

//--------------------------------------------------------
     formlayoutWidget2 = new QWidget(centralWidget); /*!< QWidget formlayoutWidget2 */
     formlayoutWidget2 -> setGeometry(QRect(75, 200, 555, 210));   /*!< set size formLayoutWidget2 */
     formlayout2 = new QFormLayout(formlayoutWidget2); /*!< formLayout2 QFormLayout*/

      vueTraj               = new QTableWidget(0, 6, formlayoutWidget2);  /*!< vueTraj of the QTableWidget */
      //formlayout2 -> setWidget(vueTraj);

      vueTraj->setEditTriggers(QAbstractItemView::NoEditTriggers);  /*!< this ligne give no edit mode*/
      vueTraj->setShowGrid(false);   /*!< this ligne cover the grille in table */
      vueTraj->setSelectionBehavior(QAbstractItemView::SelectRows); /*!< this ligne give a section of the ligne */
   //--------------------------------------------------------------
    QStringList horizontalHeaders;
    horizontalHeaders << "Nom" << "Type" << "Nbuptime" << "Offtime" << "Dtime" << "Nbsteptime";  /*!< added Nom Netward Entrees and sorties in table */
    vueTraj->setHorizontalHeaderLabels(horizontalHeaders);

    formlayout2->addRow(vueTraj); /*!< displays the QTableWidget */

    m_AjoutTraj                 = new QPushButton("Ajouter", centralWidget);  /*!< The button "Ajouter". */
    m_AjoutTraj -> setGeometry(635, 240, 68, 23); /*!< st size button */
    m_suppTraj                  = new QPushButton("Supprimer", centralWidget);  /*!< The button "Supprimer". */
    m_suppTraj -> setGeometry(635, 270, 70, 23); /*!< set size button */
//--------------------------------------------------------------------------
    m_AideTraj                 = new QPushButton("De l'aide?", centralWidget);  /*!< The button "Aide". */
    //m_AideTraj -> setGeometry(635, 280, 65, 23);  /*!< set size button  */
    m_AideTraj -> setGeometry(10, 260, 65, 23);  /*!< set size button  */ 
     formlayoutWidget3 = new QWidget(centralWidget);  /*!< formlayoutWidget3 QWidget */
     formlayoutWidget3 -> setGeometry(QRect(120, 370, 455, 151)); /*!< set size */
     formlayout3 = new QHBoxLayout(formlayoutWidget3);  /*!< formlayout3 QHBoxLayout */

     m_enregTraj                 = new QPushButton("Enregistrer", formlayoutWidget3);  /*!< QPushButton Enregistrer */
     m_quitTraj                  = new QPushButton("Quitter", formlayoutWidget3);  /*!< QPushButton Quitter */
     
    //Les gestionnaires de positionnement

   formlayout3->addWidget(m_enregTraj);  /*!< added m_enregTraj */
   //formlayout3->addWidget(m_suppTraj);
   formlayout3->addWidget(m_quitTraj);  /*!< added m_quitTraj  */

         index2 = vueTraj->currentIndex();
          //std::ostringstream oss1;
            

       for(vector<Trajectory>::iterator it=copytheTrajectoryTable->begin(); it!=copytheTrajectoryTable->end(); it++)
                {
                 
                
                }
    
        connect(m_quitTraj, SIGNAL(clicked()), this, SLOT(close()));   /*!< slot for the close this windows*/
        connect(m_suppTraj, SIGNAL(clicked()), this, SLOT(appelSupp()));   /*!< slot  for the delete the object selected in the view*/
        connect(m_AjoutTraj, SIGNAL(clicked()), this, SLOT(appelAjout()));  /*!< This slot add the object in the view */ 
        connect(m_AideTraj, SIGNAL(clicked()), this, SLOT(callTrajHelp()));   /*!< This slot opens */ 

}

/*******************************************************************************************************************************/


/*******************************************************************************************************************************/


/****************************************************************************************/
void TrajWindow::ajouterValeurDansTableau1(int ligne, int colonne, QString valeurTraj) {

QTableWidgetItem *chaine1 = new QTableWidgetItem;
chaine1->setText(valeurTraj);

    vueTraj->setItem(ligne - 1, colonne, chaine1);

}


/****************************************************************************************/
void TrajWindow::appelAjout() {

	addRow();
 static int row = 0;
  int l = 0;

QString line1 = m_ligneNomTraj->text();
QString line2 = m_ligneTypeTraj->text();
QString line3 = m_ligneNbuptimeTraj->currentText();
QString line4 = m_ligneOfftimeTraj->currentText();
QString line5 = m_ligneDtimeTraj->currentText();
QString line6 = m_ligneNbsteptimeTraj->text();

                      
    for(int i = 0; i<line1.size(); i++)
        //if (m_ligneNomTraj->text().isEmpty())
        if(!((line1.at(i) >= QChar('a')&& line1.at(i) <= QChar('z')) || (line1.at(i) >= QChar('A')&& line1.at(i) <= QChar('Z'))  //---------------
         || (line1.at(i) >= QChar('0')&& line1.at(i) <= QChar('9')) || (line1.at(i) == QChar('_')))) //|| (line1.isEmpty()) 
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer le nom de la trajectoire correcte.");
        return; // Arrêt de la méthode 
    }
      
                 for(int j = 0; j<line2.size(); j++)
              if(!((line2.at(j) >= QChar('a')&& line2.at(j) <= QChar('z')) || (line2.at(j) >= QChar('A')&& line2.at(j) <= QChar('Z'))//----------
         || (line2.at(j) >= QChar('0')&& line2.at(j) <= QChar('9')) || (line2.at(j) == QChar('_')))) 
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer un type correcte.");
        return; // Arrêt de la méthode 
    }
                    for(int k = 0; k<line3.size(); k++)
              if(!((line3.at(k) >= QChar('0')&& line3.at(k) <= QChar('9')) || (line3.at(k) == QChar('+')) || (line3.at(k) == QChar('-'))
       || (line3.at(k) == QChar('E')) || (line3.at(k) == QChar('e'))))//-------- 
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer au moins une valeur Correcte de Nbuptime.");
        return; // Arrêt de la méthode 
    }
                    for(int i1 = 0; i1<line4.size(); i1++)
              if(!((line4.at(i1) >= QChar('0')&& line4.at(i1) <= QChar('9')) || (line4.at(i1) == QChar('+')) || (line4.at(i1) == QChar('-'))
       || (line4.at(i1) == QChar('E')) || (line4.at(i1) == QChar('e')) || (line4.at(i1) == QChar('.')))) //-----------
                  
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer au moins une valeur Correcte de Offtime.");
        return; // Arrêt de la méthode 
    }
       
                for(int k1 = 0; k1<line5.size(); k1++)
              if(!((line5.at(k1) >= QChar('1')&& line5.at(k1) <= QChar('9')) || (line5.at(k1) == QChar('+')) || (line5.at(k1) == QChar('-'))
       || (line5.at(k1) == QChar('E')) || (line5.at(k1) == QChar('e'))) && (line5.at(k1) >= QChar('10')&& line5.at(k1) <= QChar('10000'))) //----------- 
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur Correcte de Dtime.");
        return; // Arrêt de la méthode 
    }

              for(int t1 = 0; t1<line6.size(); t1++)
              if(!((line6.at(t1) >= QChar('0')&& line6.at(t1) <= QChar('9')) || (line6.at(t1) == QChar('+')) || (line6.at(t1) == QChar('-'))
       || (line6.at(t1) == QChar('E')) || (line6.at(t1) == QChar('e')))) //----------- 
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer au moins une valeur Correcte de Nbsteptime.");
        return; // Arrêt de la méthode 
    }

           if (m_ligneNomTraj->text().isEmpty())
        {
    QMessageBox::critical(this, "Erreur", "Veuillez definir un nom correcte pour  la Trajectoire SVP!");
        return; // Arrêt de la méthode 
    }
        else if (m_ligneTypeTraj->text().isEmpty())
        {
    QMessageBox::critical(this, "Erreur", "Veuillez definir un Type à la Trajectoire SVP!");
        return; // Arrêt de la méthode 
    }
        else if ((m_ligneNbuptimeTraj->currentText().isEmpty()) || (m_ligneOfftimeTraj->currentText().isEmpty()) || (m_ligneDtimeTraj->currentText().isEmpty()))
        {
    QMessageBox::critical(this, "Erreur", "Veuillez remplir le champs vide SVP!");
        return; // Arrêt de la méthode 
    }


if (l >= 0)
{
      vueTraj->setItem(row, 0, new QTableWidgetItem(m_ligneNomTraj->text()));      
      vueTraj->setItem(row, 1, new QTableWidgetItem(m_ligneTypeTraj->text()));     
      vueTraj->setItem(row, 2, new QTableWidgetItem(m_ligneNbuptimeTraj->currentText()));
      vueTraj->setItem(row, 3, new QTableWidgetItem(m_ligneOfftimeTraj->currentText()));
      vueTraj->setItem(row, 4, new QTableWidgetItem(m_ligneDtimeTraj->currentText()));
      vueTraj->setItem(row, 5, new QTableWidgetItem(m_ligneNbsteptimeTraj->text()));

      //TrajData.push_back(m_ligneNomTraj->text() + " " + m_ligneTypeTraj->text() + " " + m_ligneNbuptimeTraj->currentText() +
        //                                                  " " + m_ligneOfftimeTraj->currentText() + " " + m_ligneDtimeTraj->currentText() +
         //                                                 " " + m_ligneNbsteptimeTraj->text());

 
    row++;
   }
//writefile();
 initialiserChamps();

}

/****************************************************************************************/
void TrajWindow::appelSupp() {

                 vueTraj->removeRow(vueTraj->currentRow());

               }

//****************************************************************************************/

void TrajWindow::initialiserChamps() {
                 
	m_ligneNomTraj->clear();
        //m_ligneTypeTraj->clear();
	m_ligneNbuptimeTraj->clearEditText();
        m_ligneOfftimeTraj->setEditText("0");
	//m_ligneDtimeTraj->clearEditText();
	m_ligneNbsteptimeTraj->clear();
	//m_spaceTrajname->clearEditText();

}

//******************************* Write in the .d file**********************************/
/*
void TrajWindow::writefile(){


std::ofstream file("shalw.d", std::ios_base::app);

//string monflux;

      file << "Trajectory" << " ";
      file << m_ligneNomTraj->text().toStdString().c_str() << " ";
      file << m_ligneTypeTraj->text().toStdString().c_str() << " ";
      file << m_ligneNbuptimeTraj->currentText().toStdString().c_str() << " ";
      file << m_ligneOfftimeTraj->currentText().toStdString().c_str() << " ";
      file << m_ligneDtimeTraj->currentText().toStdString().c_str() << " ";
      file << m_ligneNbsteptimeTraj->text().toStdString().c_str() << endl;
  

                            } */
/****************************************************************************************/
void TrajWindow::ecrireFichierTraj()
{
  TrajData.push_back(m_ligneNomTraj->text() + " " + m_ligneTypeTraj->text() + " " + m_ligneNbuptimeTraj->currentText() +
                                                          " " + m_ligneOfftimeTraj->currentText() + " " + m_ligneDtimeTraj->currentText() +
                                                          " " + m_ligneNbsteptimeTraj->text()); 


}

/****************************************************************************************************************************/
QStringList TrajWindow::getDataTraj() {

    //QStringList test;
     return TrajData;
} 
//******************************* Implémentation de la méthode callTrajHelp() *********************************************/

void TrajWindow::callTrajHelp() {

  QMessageBox::about(this, tr("Aide sur la directive trajectoire."),("<p> Elle sert a définir une trajectoire, "
                              "c'est-a-dire des informations sur les aspects temporels nécessaires au projet. Le principe "
                              "étant qu'une trajectoire pourra être porteuse de plusieurs espaces. <p>Les parametres à "
                              "préciser sont les suivants : <br>traj   trajname  type  nbuptime  [offtime dtime]  nbsteptime"
                              "<br> <a href=\"help/traj_aide.html\">lien HTML Cliquez ici SVP !</a>"));

}

//****************************** Implémentation de la méthode addRow ***************************************/
void TrajWindow::addRow() {

	int row = vueTraj->rowCount();
        vueTraj->insertRow(row);

}

//******************************* Implémentation de la methode saveTrajData *************************************/
void TrajWindow::saveTrajData() {     

	QTableWidgetItem *cell1 = new QTableWidgetItem;
        QTableWidgetItem *cell2 = new QTableWidgetItem; 
        QTableWidgetItem *cell3 = new QTableWidgetItem;
        QTableWidgetItem *cell4 = new QTableWidgetItem; 
        QTableWidgetItem *cell5 = new QTableWidgetItem;
        QTableWidgetItem *cell6 = new QTableWidgetItem; 
 
        for (int i = 0; i < vueTraj->rowCount() ; i++) {
                        cell1 = vueTraj->item(i,0);
                        cell2 = vueTraj->item(i,1);
			cell3 = vueTraj->item(i,2);
                        cell4 = vueTraj->item(i,3);
                        cell5 = vueTraj->item(i,4);
                        cell6 = vueTraj->item(i,5);
         

                        TrajData.push_back(cell1->text() + " " + cell2->text() + " " + cell2->text() + " " + cell2->text() + " " + cell2->text() + " " + cell2->text());
                        
                }


        }

